#ifndef _MODBUS_MSXE170X_CLIENT_DEFINITION_H_
#define _MODBUS_MSXE170X_CLIENT_DEFINITION_H_

/* this file has been generated by gModbus on Tue Apr 12 10:56:27 2016*/

#include "common_modbus_clientlib.h"



/* Symbolic names for register */
enum {
MSXE17XX__MFINCCOUNTERREAD32BITSVALUEALL=4000,
MSXE17XX__MFINCCOUNTERREAD32BITSVALUE0=4050,
MSXE17XX__MFINCCOUNTERREAD32BITSVALUE1=4100,
MSXE17XX__MFINCCOUNTERREAD32BITSVALUE2=4150,
MSXE17XX__MFINCCOUNTERREAD32BITSVALUE3=4200,
MSXE17XX__DIGITALIOREADALLCHANNELSVALUE=7000,
MSXE17XX__DIGITALIOTESTSHORTCIRCUIT=7050,
MSXE17XX__IOWATCHDOGGETSTATUSANDVALUE=8000,
MSXE170X__DIGITALIOREADALLCHANNELSVALUE=100,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE17xx__MFIncCounterRead32BitsValueAll_parameters_t
{
	uint32_t ulValues[4];
	uint32_t ulTimeStampLows[4];
	uint32_t ulTimeStampHighs[4];
 } __PACKED;

struct MSXE17xx__MFIncCounterRead32BitsValue0_parameters_t
{
	uint32_t ulValue;
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
 } __PACKED;

struct MSXE17xx__MFIncCounterRead32BitsValue1_parameters_t
{
	uint32_t ulValue;
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
 } __PACKED;

struct MSXE17xx__MFIncCounterRead32BitsValue2_parameters_t
{
	uint32_t ulValue;
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
 } __PACKED;

struct MSXE17xx__MFIncCounterRead32BitsValue3_parameters_t
{
	uint32_t ulValue;
	uint32_t ulTimeStampLow;
	uint32_t ulTimeStampHigh;
 } __PACKED;

struct MSXE17xx__DigitalIOReadAllChannelsValue_parameters_t
{
	uint32_t ulChannelsValue;
 } __PACKED;

struct MSXE17xx__DigitalIOTestShortCircuit_parameters_t
{
	uint32_t ulValue;
 } __PACKED;

struct MSXE17xx__IOWatchdogGetStatusAndValue_parameters_t
{
	uint32_t ulStatus;
	uint32_t ulValue;
	uint32_t ulInfo;
 } __PACKED;

struct MSXE170x__DigitalIOReadAllChannelsValue_parameters_t
{
	uint32_t ChannelsValue;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32



/** <p>Read measured value on all modules.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValues</VAR></b> : Array that contain the measured values.
*                                            <ul>
*                                               <li> ulValues [0] : Module 0 value
*                                               <li> ulValues [1] : Module 1 value
*                                               <li> ulValues [2] : Module 2 value
*                                               <li> ulValues [3] : Module 3 value
*                                            <ul></p>
* <p>@param[out] <b><VAR>ulTimeStampLows</VAR></b> : 32 bit low part of time stamp (us) array
*                                            <ul>
*                                               <li> ulTimeStampLows [0] : Module 0 time stamp (us)
*                                               <li> ulTimeStampLows [1] : Module 1 time stamp (us)
*                                               <li> ulTimeStampLows [2] : Module 2 time stamp (us)
*                                               <li> ulTimeStampLows [3] : Module 3 time stamp (us)
*                                            <ul></p>
* <p>@param[out] <b><VAR>ulTimeStampHighs</VAR></b> : 32 bit high part of time stamp (s) array
*                                            <ul>
*                                               <li> ulTimeStampHighs [0] : Module 0 time stamp (s)
*                                               <li> ulTimeStampHighs [1] : Module 1 time stamp (s)
*                                               <li> ulTimeStampHighs [2] : Module 2 time stamp (s)
*                                               <li> ulTimeStampHighs [3] : Module 3 time stamp (s)
*                                            <ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Multifunction sub module index selection error
*                       <li> -3: Multifunction sub module is not a incremental counter.
*                       <li> -4: Incremental counter not initialised
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFIncCounterRead32BitsValueAll(struct modbus * modbus,struct MSXE17xx__MFIncCounterRead32BitsValueAll_parameters_t * Response);



/** <p>Read measured value on the module 0.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value.</p>
* <p>@param[out] <b><VAR>ulTimeStampLow</VAR></b> : 32 bit low part of time stamp (us)</p>
* <p>@param[out] <b><VAR>ulTimeStampHigh</VAR></b> : 32 bit high part of time stamp (s)</p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Multifunction sub module index selection error
*                       <li> -3: Multifunction sub module is not a incremental counter.
*                       <li> -4: Incremental counter not initialised
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFIncCounterRead32BitsValue0(struct modbus * modbus,struct MSXE17xx__MFIncCounterRead32BitsValue0_parameters_t * Response);



/** <p>Read measured value on the module 1.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value.</p>
* <p>@param[out] <b><VAR>ulTimeStampLow</VAR></b> : 32 bit low part of time stamp (us)</p>
* <p>@param[out] <b><VAR>ulTimeStampHigh</VAR></b> : 32 bit high part of time stamp (s)</p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Multifunction sub module index selection error
*                       <li> -3: Multifunction sub module is not a incremental counter.
*                       <li> -4: Incremental counter not initialised
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFIncCounterRead32BitsValue1(struct modbus * modbus,struct MSXE17xx__MFIncCounterRead32BitsValue1_parameters_t * Response);



/** <p>Read measured value on the module 2.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value.</p>
* <p>@param[out] <b><VAR>ulTimeStampLow</VAR></b> : 32 bit low part of time stamp (us)</p>
* <p>@param[out] <b><VAR>ulTimeStampHigh</VAR></b> : 32 bit high part of time stamp (s)</p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Multifunction sub module index selection error
*                       <li> -3: Multifunction sub module is not a incremental counter.
*                       <li> -4: Incremental counter not initialised
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFIncCounterRead32BitsValue2(struct modbus * modbus,struct MSXE17xx__MFIncCounterRead32BitsValue2_parameters_t * Response);



/** <p>Read measured value on the module 3.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[out] <b><VAR>ulValue</VAR></b> : Measured value.</p>
* <p>@param[out] <b><VAR>ulTimeStampLow</VAR></b> : 32 bit low part of time stamp (us)</p>
* <p>@param[out] <b><VAR>ulTimeStampHigh</VAR></b> : 32 bit high part of time stamp (s)</p>
* </ul>
*
* <ul>
*
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Multifunction sub module index selection error
*                       <li> -3: Multifunction sub module is not a incremental counter.
*                       <li> -4: Incremental counter not initialised
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		    


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__MFIncCounterRead32BitsValue3(struct modbus * modbus,struct MSXE17xx__MFIncCounterRead32BitsValue3_parameters_t * Response);



/** <p>Read all the digital I/O channel value. If channel is configured as output, then this function return the status of the output</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[out]<b><VAR>ulChannelsValue</VAR></b> : Channels value</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__DigitalIOReadAllChannelsValue(struct modbus * modbus,struct MSXE17xx__DigitalIOReadAllChannelsValue_parameters_t * Response);



/** <pTest short circuit status</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[out]<b><VAR>ulValue</VAR></b> : short circuit status: from 0 to 0xffff, one bit for each output
*          <ul>
*             <li> 0 : no short circuit
*             <li> 1 : short circuit
*          </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__DigitalIOTestShortCircuit(struct modbus * modbus,struct MSXE17xx__DigitalIOTestShortCircuit_parameters_t * Response);



/** <p> Get watchdog current status and value information</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[out]<b><VAR>ulStatus</VAR></b> : Channels value
*    <ul>
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXX0: is stopped
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXXX1: is running
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXX0X: is not run down
*           <li> BIN XXXXXXXX XXXXXXXX XXXXXXXX XXXXXX1X: is run down
*    </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE17xx__IOWatchdogGetStatusAndValue(struct modbus * modbus,struct MSXE17xx__IOWatchdogGetStatusAndValue_parameters_t * Response);



/** <p>Read all the digital I/O channel value. If channel is configured as output, then this function return the status of the output</p>
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__DigitalIOReadAllChannelsValue.</h3>
*
* <p><b>Parameters:</b></p><ul>
*
* <ul>@param[out]<b><VAR>ChannelsValue:</VAR></b>Channels value</p></ul></ul>
*/
		


/* @return 0 on success, -1 on system error, -2 on modbus exception, -3 if the received answer is incorrect */
int modbus_call_MSXE170x__DigitalIOReadAllChannelsValue(struct modbus * modbus,struct MSXE170x__DigitalIOReadAllChannelsValue_parameters_t * Response);


/* Symbolic names for register */
enum {
MSXE17XX__MFCOMMONSETINPUTSFILTER=6000,
MSXE17XX__MFCOMMONREFERENCEVOLTAGEACTIVATION=6050,
MSXE17XX__MFCOMMONSETFIFO0LEVEL=6100,
MSXE17XX__MFCOMMONENABLEDISABLETRIGGERGATE=6150,
MSXE17XX__MFINCCOUNTERINIT=4300,
MSXE17XX__MFINCCOUNTERRELEASE=4350,
MSXE17XX__MFINCCOUNTERCLEAR=4400,
MSXE17XX__MFINCCOUNTERWRITE32BITVALUE=4450,
MSXE17XX__MFINCCOUNTERINITANDENABLECOMPARELOGIC=4500,
MSXE17XX__MFINCCOUNTERDISABLEANDRELEASECOMPARELOGIC=4550,
MSXE17XX__MFINCCOUNTERINITHARDWARETRIGGER=4600,
MSXE17XX__MFINCCOUNTERRELEASEHARDWARETRIGGER=4650,
MSXE17XX__MFINCCOUNTERINITINDEX=4700,
MSXE17XX__MFINCCOUNTERRELEASEINDEX=4750,
MSXE17XX__MFINCCOUNTERINITANDENABLELATCH=4800,
MSXE17XX__MFINCCOUNTERDISABLEANDRELEASELATCH=4850,
MSXE17XX__MFINCCOUNTERINITANDENABLECLEAR=4900,
MSXE17XX__MFINCCOUNTERDISABLEANDRELEASECLEAR=4950,
MSXE17XX__MFINCCOUNTERINITANDENABLEFREQUENCYMEASUREMENT=5000,
MSXE17XX__MFINCCOUNTERDISABLEANDRELEASEFREQUENCYMEASUREMENT=5050,
MSXE17XX__DIGITALIOWRITEALLCHANNELSVALUE=7100,
MSXE17XX__DIGITALIOREARMSHORTCIRCUIT=7150,
MSXE17XX__DIGITALIOINITPORT=7200,
MSXE17XX__IOWATCHDOGINITANDSTART=8050,
MSXE17XX__IOWATCHDOGSTOPANDRELEASE=8100,
MSXE170X__MFINCCOUNTERINIT=1,
MSXE170X__MFINCCOUNTERRELEASE=2,
MSXE170X__MFINCCOUNTERCLEAR=3,
MSXE170X__MFINCCOUNTERINITANDENABLELATCHREGISTER=4,
MSXE170X__MFINCCOUNTERDISABLEANDRELEASELATCHREGISTER=5,
MSXE170X__MFINCCOUNTERWRITE32BITVALUE=6,
MSXE170X__MFINCCOUNTERSETFIFO0LEVEL=8,
MSXE170X__DIGITALIOWRITEALLCHANNELSVALUE=7,
};

#ifdef WIN32
#pragma pack(1)
#endif // WIN32

struct MSXE17xx__MFCommonSetInputsFilter_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulInputAFilterValue;
	uint32_t ulInputBFilterValue;
	uint32_t ulInputCFilterValue;
	uint32_t ulInputDFilterValue;
 } __PACKED;

struct MSXE17xx__MFCommonReferenceVoltageActivation_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulActivationFlag;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFCommonSetFIFO0Level_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulFIFOLevel;
	uint32_t ulTimeOutTimeBase;
	uint32_t ulReloadValue;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFCommonEnableDisableTriggerGate_parameters_t
{
	uint32_t ulTriggerConfiguration;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterInit_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterMode;
	uint32_t ulCounterOption;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;
 } __PACKED;

struct MSXE17xx__MFIncCounterRelease_parameters_t
{
	uint32_t ulMFModuleIndex;
 } __PACKED;

struct MSXE17xx__MFIncCounterClear_parameters_t
{
	uint32_t ulMFModuleIndex;
 } __PACKED;

struct MSXE17xx__MFIncCounterWrite32BitValue_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterValue;
 } __PACKED;

struct MSXE17xx__MFIncCounterInitAndEnableCompareLogic_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulValue;
	uint32_t ulMode;
	uint32_t ulSynchroTrigger;
	uint32_t ulLatchDigValue;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic_parameters_t
{
	uint32_t ulMFModuleIndex;
 } __PACKED;

struct MSXE17xx__MFIncCounterInitHardwareTrigger_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulCount;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterReleaseHardwareTrigger_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFIncCounterInitIndex_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterReleaseIndex_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFIncCounterInitAndEnableLatch_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulLatchDigValue;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterDisableAndReleaseLatch_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFIncCounterInitAndEnableClear_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterDisableAndReleaseClear_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulTimingInterval;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE17xx__DigitalIOWriteAllChannelsValue_parameters_t
{
	uint32_t ulValue;
 } __PACKED;

struct MSXE17xx__DigitalIORearmShortCircuit_parameters_t
{
	uint32_t ulOption;
 } __PACKED;

struct MSXE17xx__DigitalIOInitPort_parameters_t
{
	uint32_t ulPort;
	uint32_t ulPortConfiguration;
 } __PACKED;

struct MSXE17xx__IOWatchdogInitAndStart_parameters_t
{
	uint32_t ulTimeBase;
	uint32_t ulTimeValue;
	uint32_t ulOption1;
	uint32_t ulOption2;
 } __PACKED;

struct MSXE17xx__IOWatchdogStopAndRelease_parameters_t
{
	uint32_t ulOption;
 } __PACKED;

struct MSXE170x__MFIncCounterInit_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterMode;
	uint32_t ulCounterOption;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;
 } __PACKED;

struct MSXE170x__MFIncCounterRelease_parameters_t
{
	uint32_t ulMFModuleIndex;
 } __PACKED;

struct MSXE170x__MFIncCounterClear_parameters_t
{
	uint32_t ulMFModuleIndex;
 } __PACKED;

struct MSXE170x__MFIncCounterInitAndEnableLatchRegister_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchRegister;
	uint32_t ulHardwareTriggerEdgeSelection;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE170x__MFIncCounterDisableAndReleaseLatchRegister_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchRegister;
	uint32_t ulOption01;
 } __PACKED;

struct MSXE170x__MFIncCounterWrite32BitValue_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterValue;
 } __PACKED;

struct MSXE170x__MFIncCounterSetFIFO0Level_parameters_t
{
	uint32_t ulMFModuleIndex;
	uint32_t ulFIFOLevel;
	uint32_t ulOption01;
	uint32_t ulOption02;
 } __PACKED;

struct MSXE170x__DigitalIOWriteAllChannelsValue_parameters_t
{
	uint32_t ulValue;
 } __PACKED;

#ifdef WIN32
#pragma pack()
#endif // WIN32


/** <p>Set a filter to the input of a multifunction sub module.</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3)</p>
* <p>@param[in] <b><VAR>ulInputAFilterValue</VAR></b> : Filter value for input A (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulInputBFilterValue</VAR></b> : Filter value for input B (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulInputCFilterValue</VAR></b> : Filter value for input C (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulInputDFilterValue</VAR></b> : Filter value for input D (0 to 262143).
*    <ul>
*                             <li> 0: Filter nicht benutzt
*                             <li> 1: 100 ns
*                             <li> 2: 200 ns
*                             <li> 3: 300 ns ...
*                             <li> 262143 : 26,2143 ms
*    </ul>
* </p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : Multifunction sub module index selection error
*                       <li> -3 : Input A filter value selection error
*                       <li> -4 : Input B filter value selection error
*                       <li> -5 : Input C filter value selection error
*                       <li> -6 : Input D filter value selection error
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonSetInputsFilter(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulInputAFilterValue;
	uint32_t ulInputBFilterValue;
	uint32_t ulInputCFilterValue;
	uint32_t ulInputDFilterValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonSetInputsFilter(modbus,ulMFModuleIndex,ulInputAFilterValue,ulInputBFilterValue,ulInputCFilterValue,ulInputDFilterValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonSetInputsFilter");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonSetInputsFilter\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonSetInputsFilter()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonSetInputsFilter OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonSetInputsFilter(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulInputAFilterValue,
	uint32_t ulInputBFilterValue,
	uint32_t ulInputCFilterValue,
	uint32_t ulInputDFilterValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Permit to activate the reference voltage to pin D-</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3)</p>
* <p>@param[in] <b><VAR>ulActivationFlag</VAR></b> : Filter value for input A (0 to 262143).
*    <ul>
*                             <li> 0: normal mode from D- (Default mode)
*                             <li> 1: activate the reference voltage to pin D-
*    </ul>
* </p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : Multifunction sub module index selection error \n
*                       <li> -3 : Activation flag selection error \n
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonReferenceVoltageActivation(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulActivationFlag;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonReferenceVoltageActivation(modbus,ulMFModuleIndex,ulActivationFlag,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonReferenceVoltageActivation");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonReferenceVoltageActivation\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonReferenceVoltageActivation()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonReferenceVoltageActivation OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonReferenceVoltageActivation(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulActivationFlag,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Define the number of data bloc in the first FIFO before transmit the datas</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3)</p>
* <p>@param[in] <b><VAR>ulFIFOLevel</VAR></b> : Define the FIFO level (1 to 200).</p>
* <p>@param[in] <b><VAR>ulTimeOutTimeBase</VAR></b> : Define a Time out : permit to receive the data from the FIFO before the FIFO level is reached.\n
*                                                     Time base of the timer (0: disabled, 1 for us, 2 for ms, 3 for s)</p>
* <p>@param[in] <b><VAR>ulReloadValue</VAR></b> : Time out reload value (1 to 0xFFFF)</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : Multifunction sub module index selection error
*                       <li> -3 : FIFO level value is wrong
*                       <li> -4 : Time out time base selection error
*                       <li> -5 : Time out value can not be null, if a time base is selected
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonSetFIFO0Level(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulFIFOLevel;
	uint32_t ulTimeOutTimeBase;
	uint32_t ulReloadValue;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonSetFIFO0Level(modbus,ulMFModuleIndex,ulFIFOLevel,ulTimeOutTimeBase,ulReloadValue,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonSetFIFO0Level");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonSetFIFO0Level\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonSetFIFO0Level()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonSetFIFO0Level OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonSetFIFO0Level(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulFIFOLevel,
	uint32_t ulTimeOutTimeBase,
	uint32_t ulReloadValue,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Define the number of data bloc in the first FIFO before transmit the datas</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulTriggerConfiguration</VAR></b> : Trigger configuration:</p>
*    <ul>
*                             <li> Bit 0: Hardware trigger</li>
*                             <ul>
*                                 <li> 0 : Disable hardware trigger gate</li>
*                                 <li> 1 : Enable hardware trigger gate</li>
*                             </ul>
*    </ul>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set it to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set it to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2 : ulTriggerConfiguration parameter is wrong
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFCommonEnableDisableTriggerGate(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulTriggerConfiguration;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFCommonEnableDisableTriggerGate(modbus,ulTriggerConfiguration,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFCommonEnableDisableTriggerGate");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFCommonEnableDisableTriggerGate\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFCommonEnableDisableTriggerGate()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFCommonEnableDisableTriggerGate OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFCommonEnableDisableTriggerGate(struct modbus * modbus,
	uint32_t ulTriggerConfiguration,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Initialise the counter
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulCounterMode</b>  : Set the counter mode : either \n
*	<ul>
*                              <li> MSXE170X_COUNTER_QUADRUPLE_MODE (0x4) \n
*                              <li> MSXE170X_COUNTER_DOUBLE_MODE (0x2) \n
*                              <li> MSXE170X_COUNTER_SIMPLE_MODE (0x1) \n
*                              <li> MSXE170X_COUNTER_DIRECT_MODE (0x0)
*	</ul>
*
* @param[in] <li> <b>ulCounterOption</b> : Set the counter option \n
*                              if in QUADRUPLE/DOUBLE/SIMPLE mode : either \n
*	<ul>
*                             <li> MSXE170X_COUNTER_HYSTERESIS_ON (0x1) \n
*                             <li> MSXE170X_COUNTER_HYSTERESIS_OFF (0x0) \n
*	</ul>
*
*                              if in DIRECT mode : \n
*	<ul>
*                             <li> MSXE170X_COUNTER_INCREMENT (0x0) \n
*                             <li> MSXE170X_COUNTER_DECREMENT (0x1)
*	</ul>
*
* @param[in] <li> <b>ulOption01</b> : Set it to 0
* @param[in] <li> <b>ulOption02</b> : Set it to 0
* @param[in] <li> <b>ulOption03</b> : Set it to 0
* @param[in] <li> <b>ulOption04</b> : Set it to 0
* </ul>
* @param[out] <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Counter mode selection error
*                            <li> -4: Counter option selection error
*                            <li> -5: Multifunction sub module is not a incremental counter
*                            <li> -100: Init counter kernel function error
* </ul>
*
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterMode;
	uint32_t ulCounterOption;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInit(modbus,ulMFModuleIndex,ulCounterMode,ulCounterOption,ulOption01,ulOption02,ulOption03,ulOption04,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInit OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInit(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulCounterMode,
	uint32_t ulCounterOption,
	uint32_t ulOption01,
	uint32_t ulOption02,
	uint32_t ulOption03,
	uint32_t ulOption04
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Release the counter
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* </ul>
* @param[out] <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
* </ul>
*
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterRelease(modbus,ulMFModuleIndex,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterRelease(struct modbus * modbus,
	uint32_t ulMFModuleIndex
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Clear the 32 bits counter
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* </ul>
* @param[out] <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
* <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter
*                            <li> -4: Incremental counter not initialised
*                            <li> -100: Kernel function error
*
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterClear(modbus,ulMFModuleIndex,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterClear(struct modbus * modbus,
	uint32_t ulMFModuleIndex
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** write a 32 bits counter value
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulCounterValue</b> : Counter value
* </ul>
* @param[out] <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Counter value error
*                            <li> -4: Multifunction sub module is not a incremental counter
*                            <li> -5: Incremental counter not initialised
*                            <li> -100: Kernel function error
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterWrite32BitValue(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterWrite32BitValue(modbus,ulMFModuleIndex,ulCounterValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterWrite32BitValue");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterWrite32BitValue\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterWrite32BitValue()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterWrite32BitValue OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterWrite32BitValue(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulCounterValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable a counter compare value</p>
*
*<p>
For each latch the data server send a 5 DWORD frame with following informations:<br>
<ul>
  <li>DWORD 0 : Time stamp micro s
  <li>DWORD 1 : Time stamp s
  <li>DWORD 2 :
  <ul>
     <li>D1-D0   : Sub module index (0 to 3)
     <li>D31-D16 : Sub module functionality (0) 
     <li>		   or value of the digital inputs when ulLatchDigValue is enabled
  </ul>
  <li>DWORD 3 : Event mask
  <ul>
     <li><p>D31-D0 :<br>
        0: Compare <br>
        1: Frequency measurement <br>
        2: Hardware trigger latch occur <br>
        3: Synchro input latch occur <br>
        4: Index input latch occur</p>
  </ul>
  <li>DWORD 4 :
  <ul>
     <li>D31-D0: Counter value (DWORD)
  </ul>
</ul>
</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulValue / ulValueLow</VAR></b> : compare value (double). ulValueLow</p>
* <p>@param[in] <b><VAR>ulMode</VAR></b> : compare mode \n
*     <ul>
*                                     <li> 0: condition true when counter equals compare value
*                                     <li> 1: condition true when counter equals a multiple of the compare value
*     </ul></p>
* <p>@param[in] <b><VAR>ulSynchroTrigger</VAR></b> \n
*     <ul>
*                                     <li> 0 : no synchro trigger
*                                     <li> 1 : generates a synchro trigger when condition is true
*     </ul></p>
* <p>@param[in] <b><VAR>ulLatchDigValue</VAR></b> : Parallel latch of the digital inputs \n
*     <ul>
*                            <li>  0: The value of the digital inputs are not latched.
*                            <li>  1: The Value of the digital inputs are latched and stored in the upper 16 Bits of the data package for source counter.  
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Compare value error
*                            <li> -4: Compare mode error
*                            <li> -5: Synchro trigger error
*                            <li> -6: Multifunction sub module is not a incremental counter
*                            <li> -7: Incremental counter not initialised
*                            <li> -8: Compare logic already initialised
*                            <li> -100: Init and enable counter compare kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInitAndEnableCompareLogic(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulValue;
	uint32_t ulMode;
	uint32_t ulSynchroTrigger;
	uint32_t ulLatchDigValue;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInitAndEnableCompareLogic(modbus,ulMFModuleIndex,ulValue,ulMode,ulSynchroTrigger,ulLatchDigValue,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInitAndEnableCompareLogic");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInitAndEnableCompareLogic\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInitAndEnableCompareLogic()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInitAndEnableCompareLogic OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInitAndEnableCompareLogic(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulValue,
	uint32_t ulMode,
	uint32_t ulSynchroTrigger,
	uint32_t ulLatchDigValue,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release a counter compare value</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Compare logic not initialised
*                            <li> -100: Disable counter compare value kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic(modbus,ulMFModuleIndex,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseCompareLogic(struct modbus * modbus,
	uint32_t ulMFModuleIndex
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init the hardware trigger configuration</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulEdgeSelection</VAR></b> : Front selection \n
*     <ul>
*                                       <li> 01 : rising front
*                                       <li> 10 : falling front
*                                       <li> 11 : Both front
*     </ul></p>
* <p>@param[in] <b><VAR>ulCount</VAR></b> :Define the number of trigger events before the action occur \n
*     <ul>
*                                       <li> 1 : all trigger event start the action
*                                       <li> max value : 65535
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* <p>@param[in] <b><VAR>ulOption02 </VAR></b>: set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Trigger edge selection error
*                            <li> -5: Trigger count selection error
*                            <li> -6: Incremental counter not initialised
*                            <li> -7: Hardware trigger already initialised
*                            <li> -100: Init hardware trigger kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInitHardwareTrigger(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulCount;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInitHardwareTrigger(modbus,ulMFModuleIndex,ulEdgeSelection,ulCount,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInitHardwareTrigger");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInitHardwareTrigger\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInitHardwareTrigger()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInitHardwareTrigger OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInitHardwareTrigger(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulEdgeSelection,
	uint32_t ulCount,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the hardware trigger</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Hardware trigger not initialised
*                            <li> -6: Hardware trigger used and can not released
*                            <li> -100: Release hardware trigger kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterReleaseHardwareTrigger(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterReleaseHardwareTrigger(modbus,ulMFModuleIndex,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterReleaseHardwareTrigger");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterReleaseHardwareTrigger\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterReleaseHardwareTrigger()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterReleaseHardwareTrigger OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterReleaseHardwareTrigger(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init the index configuration</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulEdgeSelection</VAR></b> : Front selection
*     <ul>
*                                       <li> 01 : rising front
*                                       <li> 10 : falling front
*                                       <li> 11 : Both front
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* <p>@param[in] <b><VAR>ulOption02 </VAR></b>: set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Index edge selection error
*                            <li> -5: Incremental counter not initialised
*                            <li> -6: Index already initialised
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInitIndex(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulEdgeSelection;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInitIndex(modbus,ulMFModuleIndex,ulEdgeSelection,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInitIndex");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInitIndex\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInitIndex()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInitIndex OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInitIndex(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulEdgeSelection,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Release the index</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Index not initialised
*                            <li> -6: Index used and can not released
*                            <li> -100: Release Index kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterReleaseIndex(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterReleaseIndex(modbus,ulMFModuleIndex,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterReleaseIndex");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterReleaseIndex\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterReleaseIndex()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterReleaseIndex OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterReleaseIndex(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable a counter latch logic</p>
*
*<p>
For each latch the data server send a 5 DWORD frame with following informations:<br>
<ul>
  <li>DWORD 0 : Time stamp micro s
  <li>DWORD 1 : Time stamp s
  <li>DWORD 2 :
  <ul>
     <li>D1-D0   : Sub module index (0 to 3)
     <li>D31-D16 : Sub module functionality (0) 
     <li>		   or value of the digital inputs when ulLatchDigValue is enabled
  </ul>
  <li>DWORD 3 : Event mask
  <ul>
     <li><p>D31-D0 :<br>
        0: Compare <br>
        1: Frequency measurement <br>
        2: Hardware trigger latch occur <br>
        3: Synchro input latch occur <br>
        4: Index input latch occur</p>
  </ul>
  <li>DWORD 4 :
  <ul>
     <li>D31-D0: Counter value (DWORD)
  </ul>
</ul>
</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : Index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulLatchSource</VAR></b> : Latch source. \n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulCondition</VAR></b> : Previously condition for accept the latch source \n
*     <ul>
*                            <li>  0: No previously condition required
*                            <li>  1: Index input condition required (Only if index input not selected selected for the latch source)
*                            <li>  2: Hardware trigger condition required (Only if hardware trigger not selected selected for the latch source)
*                            <li>  3: Synchro input condition required (Only if synchro input not selected selected for the latch source)
*     </ul></p>
* <p>@param[in] <b><VAR>ulAutoMode</VAR></b> : Action mode \n
*     <ul>
*                            <li>  0: Do not use auto mode (action is done only once)
*                            <li>  1: Use auto mode (action is done continously)
*     </ul></p>
* <p>@param[in] <b><VAR>ulLatchDigValue</VAR></b> : Parallel latch of the digital inputs \n
*     <ul>
*                            <li>  0: The value of the digital inputs are not latched.
*                            <li>  1: The Value of the digital inputs are latched and stored in the upper 16 Bits of the data package for source counter.  
*     </ul></p>* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Latch logic already initialised
*                            <li> -6: Latch source selection error
*                            <li> -7: Previously condition selection error
*                            <li> -8: Auto mode selection error
*                            <li> -9: Hardware trigger not initialised. Refer to MSXE17xx__MFIncCounterInitHardwareTrigger
*                            <li> -10: Index input not initialised. Refer to MSXE17xx__MFIncCounterInitIndex
*                            <li> -100: Init and enable counter latch kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInitAndEnableLatch(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulLatchDigValue;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInitAndEnableLatch(modbus,ulMFModuleIndex,ulLatchSource,ulCondition,ulAutoMode,ulLatchDigValue,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInitAndEnableLatch");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInitAndEnableLatch\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInitAndEnableLatch()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInitAndEnableLatch OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInitAndEnableLatch(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulLatchSource,
	uint32_t ulCondition,
	uint32_t ulAutoMode,
	uint32_t ulLatchDigValue,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release a counter latch logic</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulLatchSource</VAR></b> : Latch source to disable and release.\n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Latch logic not initialised
*                            <li> -6: Latch source selection error
*                            <li> -100: Disable and release counter latch register kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterDisableAndReleaseLatch(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchSource;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseLatch(modbus,ulMFModuleIndex,ulLatchSource,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterDisableAndReleaseLatch");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterDisableAndReleaseLatch\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterDisableAndReleaseLatch()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterDisableAndReleaseLatch OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseLatch(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulLatchSource,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable a counter clear logic</p>
*
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : Index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulClearSource</VAR></b> : Clear source. \n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulCondition</VAR></b> : Previously condition for accept the clear source \n
*     <ul>
*                            <li>  0: No previously condition required
*                            <li>  1: Index input condition required (Only if index input not selected selected for the clear source)
*                            <li>  2: Hardware trigger condition required (Only if hardware trigger not selected selected for the clear source)
*                            <li>  3: Synchro input condition required (Only if synchro input not selected selected for the clear source)
*     </ul></p>
* <p>@param[in] <b><VAR>ulAutoMode</VAR></b> : Action mode \n
*     <ul>
*                            <li>  0: Do not use auto mode (action is done only once)
*                            <li>  1: Use auto mode (action is done continously)
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Clear logic already initialised
*                            <li> -6: Clear source selection error
*                            <li> -7: Previously condition selection error
*                            <li> -8: Auto mode selection error
*                            <li> -9: Hardware trigger not initialised. Refer to MSXE17xx__MFIncCounterInitHardwareTrigger
*                            <li> -10: Index input not initialised. Refer to MSXE17xx__MFIncCounterInitIndex
*                            <li> -100: Init and enable counter clear kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInitAndEnableClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulCondition;
	uint32_t ulAutoMode;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInitAndEnableClear(modbus,ulMFModuleIndex,ulClearSource,ulCondition,ulAutoMode,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInitAndEnableClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInitAndEnableClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInitAndEnableClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInitAndEnableClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInitAndEnableClear(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulClearSource,
	uint32_t ulCondition,
	uint32_t ulAutoMode,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and Release a counter clear logic</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulClearSource</VAR></b> : Clear source to disable and release. \n
*     <ul>
*                            <li>  0: Index input
*                            <li>  1: Hardware trigger
*                            <li>  2: Synchro input
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not a incremental counter.
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Clear logic not initialised
*                            <li> -6: Clear source selection error
*                            <li> -100: Disable and release counter clear register kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterDisableAndReleaseClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulClearSource;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseClear(modbus,ulMFModuleIndex,ulClearSource,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterDisableAndReleaseClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterDisableAndReleaseClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterDisableAndReleaseClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterDisableAndReleaseClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseClear(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulClearSource,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and enable frequency measurement</p>
*<p>
For each latch the data server send a 5 DWORD frame with following informations:<br>
<ul>
  <li>DWORD 0 : Time stamp micro s
  <li>DWORD 1 : Time stamp s
  <li>DWORD 2 : Counter index
  <ul>
     <li>D1-D0   : Sub module index (0 to 3)
     <li>D31-D16 : Sub module functionality (0) 
     <li>		   or value of the digital inputs when ulLatchDigValue is enabled
  </ul>
  <li>DWORD 3 : Event mask
  <ul>
     <li><p>D31-D0 :<br>
        0: Compare <br>
        1: Frequency measurement <br>
        2: Hardware trigger latch occur <br>
        3: Synchro input latch occur <br>
        4: Index input latch occur</p>
  </ul>
  <li>DWORD 4 :
  <ul>
     <li>D31-D0: Counter value (DWORD)
  </ul>
</ul>
</p>
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulTimingInterval</VAR></b> : Timing interval from 1 to 0xFFFF, one step correspond to 100 ns.\n
*     <ul>
*                            <li>  1: Time interval = 100 ns </li>
*                            <li>  2: Time interval = 200 ns </li>
*                            <li>  ... </li>
*     </ul></p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set the measure mode\n
* <ul>
*                            <li>  0: One shot, the frequency measure is done at each call of this function</li>
*                            <li>  1: Triggered mode, this function has to be called only once (to initialize the measure). The synchro trigger is used to trigger the measure. The synchro trigger cycle time should be > frequency time interval</li>
* </ul></p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : set the measure time base\n
* <ul>
*                            <li>  0: 100 ns</li>
*                            <li>  1: 100 us</li>
* </ul></p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Timing interval selection error
*                            <li> -4: Multifunction sub module is not an incremental counter
*                            <li> -5: Incremental counter not initialised
*                            <li> -6: Frequency measurement already initialised and started
*                            <li> -7: Frequency measurement wrong mode paramter
*                            <li> -8: Frequency measurement wrong time base parameter
*                            <li> -100: Init and enable frequency measurement kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulTimingInterval;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement(modbus,ulMFModuleIndex,ulTimingInterval,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterInitAndEnableFrequencyMeasurement(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulTimingInterval,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Disable and release frequency measurement</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulMFModuleIndex</VAR></b> : index of the multifunction sub module (0 to 3).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : set it to 0</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -2: Multifunction sub module index selection error
*                            <li> -3: Multifunction sub module is not an incremental counter
*                            <li> -4: Incremental counter not initialised
*                            <li> -5: Frequency measurement not initialised
*                            <li> -100: Init and enable frequency measurement kernel function error
*     </ul>
* </ul>
*/
		    
/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement(modbus,ulMFModuleIndex,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__MFIncCounterDisableAndReleaseFrequencyMeasurement(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Write all digital i/o channels value. if the channel is define as input, nothing append on this channel.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in]<b><VAR>ulValue</VAR></b> : Channels value</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                            <li>  0: means the remote function performed OK
*                            <li> -1: means an system error occured
*                            <li> -100: Write digital I/O kernel function error
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__DigitalIOWriteAllChannelsValue(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__DigitalIOWriteAllChannelsValue(modbus,ulValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__DigitalIOWriteAllChannelsValue");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__DigitalIOWriteAllChannelsValue\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__DigitalIOWriteAllChannelsValue()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__DigitalIOWriteAllChannelsValue OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__DigitalIOWriteAllChannelsValue(struct modbus * modbus,
	uint32_t ulValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Rearm digital outputs after a short circuit happened.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulOption</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__DigitalIORearmShortCircuit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__DigitalIORearmShortCircuit(modbus,ulOption,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__DigitalIORearmShortCircuit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__DigitalIORearmShortCircuit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__DigitalIORearmShortCircuit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__DigitalIORearmShortCircuit OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__DigitalIORearmShortCircuit(struct modbus * modbus,
	uint32_t ulOption
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Initialise a digital i/o port (2 channels).</p>
*
* <p><b>Parameters:</b></p>
* <ul>
* <p>@param[in] <b><VAR>ulPort</VAR></b> : Index of the digital i/o port (0 to 7).</p>
* <p>@param[in] <b><VAR>ulPortConfiguration</VAR></b> : Define the port configuration
*    <ul>
*                             <li> 0 : input
*                             <li> 1 : output
*    </ul>
* </ul></p>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>\n
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : means an system error occured
*                       <li> -2: Digital i/o port selection error
*                       <li> -3: Port configuration selection error
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__DigitalIOInitPort(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulPort;
	uint32_t ulPortConfiguration;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__DigitalIOInitPort(modbus,ulPort,ulPortConfiguration,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__DigitalIOInitPort");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__DigitalIOInitPort\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__DigitalIOInitPort()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__DigitalIOInitPort OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__DigitalIOInitPort(struct modbus * modbus,
	uint32_t ulPort,
	uint32_t ulPortConfiguration
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Init and start the digital output IO watchdog.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulTimeBase</VAR></b> : Time base of the watchdog delay (0 for mus, 1 for ms, 2 for s)</p>
* <p>@param[in] <b><VAR>ulTimeValue</VAR></b> : Time base of the watchdog delay (0 to 0xFFFF).</p>
* <p>@param[in] <b><VAR>ulOption01</VAR></b> : Reserved. Set to 0.</p>
* <p>@param[in] <b><VAR>ulOption02</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -2:: Time base selection error
*                       <li> -3:: Time value selection error
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__IOWatchdogInitAndStart(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulTimeBase;
	uint32_t ulTimeValue;
	uint32_t ulOption1;
	uint32_t ulOption2;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__IOWatchdogInitAndStart(modbus,ulTimeBase,ulTimeValue,ulOption1,ulOption2,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__IOWatchdogInitAndStart");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__IOWatchdogInitAndStart\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__IOWatchdogInitAndStart()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__IOWatchdogInitAndStart OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__IOWatchdogInitAndStart(struct modbus * modbus,
	uint32_t ulTimeBase,
	uint32_t ulTimeValue,
	uint32_t ulOption1,
	uint32_t ulOption2
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** <p>Stop and release the digital output watchdog.</p>
*
* <p><b>Parameters:</b></p>
*
* <ul>
* <p>@param[in] <b><VAR>ulOption</VAR></b> : Reserved. Set to 0.</p>
* </ul>
*
* <ul>
* <p><b> Returns:</b></p>
* @return <li><b>Possible return value on the remote system (read them with GetLastCommandStatus):</b>
*     <ul>
*                       <li>  0 : No error.
*                       <li> -1 : Means an system error occured
*                       <li> -100 : Kernel function error (see syserrno).
*     </ul>
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE17xx__IOWatchdogStopAndRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulOption;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE17xx__IOWatchdogStopAndRelease(modbus,ulOption,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE17xx__IOWatchdogStopAndRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE17xx__IOWatchdogStopAndRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE17xx__IOWatchdogStopAndRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE17xx__IOWatchdogStopAndRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE17xx__IOWatchdogStopAndRelease(struct modbus * modbus,
	uint32_t ulOption
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Initialise the counter
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFIncCounterInit.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulCounterMode</b>  : Set the counter mode : either \n
*	<ul>
*                              <li> MSXE170X_COUNTER_QUADRUPLE_MODE (0x4) \n
*                              <li> MSXE170X_COUNTER_DOUBLE_MODE (0x2) \n
*                              <li> MSXE170X_COUNTER_SIMPLE_MODE (0x1) \n
*                              <li> MSXE170X_COUNTER_DIRECT_MODE (0x0)
*	</ul>
*
* @param[in] <li> <b>ulCounterOption</b> : Set the counter option \n
*                              if in QUADRUPLE/DOUBLE/SIMPLE mode : either \n
*	<ul>
*                             <li> MSXE170X_COUNTER_HYSTERESIS_ON (0x1) \n
*                             <li> MSXE170X_COUNTER_HYSTERESIS_OFF (0x0) \n
*	</ul>
*
*                              if in DIRECT mode : \n
*	<ul>
*                             <li> MSXE170X_COUNTER_INCREMENT (0x0) \n
*                             <li> MSXE170X_COUNTER_DECREMENT (0x1)
*	</ul>
*
* @param[in] <li> <b>ulOption01</b> : Set it to 0
* @param[in] <li> <b>ulOption02</b> : Set it to 0
* @param[in] <li> <b>ulOption03</b> : Set it to 0
* @param[in] <li> <b>ulOption04</b> : Set it to 0
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
*                            <li> -3: Counter mode selection error \n
*                            <li> -4: Counter option selection error \n
*                            <li> -5: Counter filter selection error \n
*                            <li> -100: Init counter kernel function error \n
* </ul>
*
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterInit(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterMode;
	uint32_t ulCounterOption;
	uint32_t ulOption01;
	uint32_t ulOption02;
	uint32_t ulOption03;
	uint32_t ulOption04;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterInit(modbus,ulMFModuleIndex,ulCounterMode,ulCounterOption,ulOption01,ulOption02,ulOption03,ulOption04,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterInit");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterInit\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterInit()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterInit OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterInit(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulCounterMode,
	uint32_t ulCounterOption,
	uint32_t ulOption01,
	uint32_t ulOption02,
	uint32_t ulOption03,
	uint32_t ulOption04
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Release the counter
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFIncCounterRelease.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
* </ul>
*
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterRelease(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterRelease(modbus,ulMFModuleIndex,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterRelease");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterRelease\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterRelease()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterRelease OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterRelease(struct modbus * modbus,
	uint32_t ulMFModuleIndex
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Clear the 32 bits counter
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFIncCounterClear.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
*                            <li> -100: Write counter value kernel function error \n
*
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterClear(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterClear(modbus,ulMFModuleIndex,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterClear");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterClear\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterClear()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterClear OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterClear(struct modbus * modbus,
	uint32_t ulMFModuleIndex
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Init and enable a counter latch register
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFIncCounterInitAndEnableLatch.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulLatchRegister</b> : 0: First Latch Register used with trigger input, 1: Second Lath Register used with synchro input
* @param[in] <li> <b>ulHardwareTriggerEdgeSelection</b> : not used for the synchro input \n
*	<ul>
*				 	<li> 01 : rising front (Only if trigger input selected) \n
*				 	<li> 10 : falling front (Only if trigger input selected) \n
*				 	<li> 11 : Both front (Only if trigger input selected) \n
*	</ul>
*
* @param[in] <li> <b>ulHardwareTriggerCount</b> : not used for the synchro input \n
* 							  Define the number of trigger events before the action occur \n
*                             1 : all trigger event start the action \n
*                             max value : 65535
* @param[in] <li> <b>ulOption01</b> : set it to 0
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
*                            <li> -3: Latch register selection error \n
*                            <li> -4: Trigger edge selection error \n
*                            <li> -5: Trigger count selection error \n
*                            <li> -100: Init and enable counter latch register kernel function error \n
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterInitAndEnableLatchRegister(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchRegister;
	uint32_t ulHardwareTriggerEdgeSelection;
	uint32_t ulHardwareTriggerCount;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterInitAndEnableLatchRegister(modbus,ulMFModuleIndex,ulLatchRegister,ulHardwareTriggerEdgeSelection,ulHardwareTriggerCount,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterInitAndEnableLatchRegister");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterInitAndEnableLatchRegister\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterInitAndEnableLatchRegister()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterInitAndEnableLatchRegister OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterInitAndEnableLatchRegister(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulLatchRegister,
	uint32_t ulHardwareTriggerEdgeSelection,
	uint32_t ulHardwareTriggerCount,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Disable and Release a counter latch register
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFIncCounterDisableAndReleaseLatch.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulLatchRegister</b> : 0: First Lath Register used with 24 V input, 1: Second Lath Register used with synchro input
* @param[in] <li> <b>ulOption01</b> : set it to 0
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
*                            <li> -3: Latch register selection error \n
*                            <li> -100: Disable and release counter latchd register kernel function error \n
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterDisableAndReleaseLatchRegister(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulLatchRegister;
	uint32_t ulOption01;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterDisableAndReleaseLatchRegister(modbus,ulMFModuleIndex,ulLatchRegister,ulOption01,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterDisableAndReleaseLatchRegister");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterDisableAndReleaseLatchRegister\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterDisableAndReleaseLatchRegister()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterDisableAndReleaseLatchRegister OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterDisableAndReleaseLatchRegister(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulLatchRegister,
	uint32_t ulOption01
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** write a 32 bits counter value
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFIncCounterWrite32BitValue.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulCounterValue</b> : Counter value
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
*                            <li> -3: Counter value error \n
*                            <li> -100: Write counter value kernel function error \n
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterWrite32BitValue(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulCounterValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterWrite32BitValue(modbus,ulMFModuleIndex,ulCounterValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterWrite32BitValue");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterWrite32BitValue\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterWrite32BitValue()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterWrite32BitValue OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterWrite32BitValue(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulCounterValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Define the number of data bloc in the first FIFO before transmit the datas.
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__MFCommonSetFIFO0Level.</h3>
*
* <ul>
* @param[in] <li> <b>ulMFModuleIndex</b> : index of the multifunction sub module (0 to 3). \n
* @param[in] <li> <b>ulFIFOLevel</b> : Define the FIFO level (1 to 200)
* @param[in] <li> <b>ulOption01</b> : Define a Time out : permit to receive the data from the FIFO before the FIFO level is reached \n
*                         D31-D16 : Time base: 1:us, 2:ms, 3:s\n
*                         D15-D0 : Time value\n
*                         if this value is 0, then no time out used \n
* @param[in] <li> <b>ulOption02</b> : set it to 0
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -2: Multifunction sub module index selection error \n
*                            <li> -3: FIFO level value is wrong \n
*                            <li> -4: Time out time base selection error \n
*                            <li> -5: Time out value can not be null, if a time base is selected \n
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__MFIncCounterSetFIFO0Level(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulMFModuleIndex;
	uint32_t ulFIFOLevel;
	uint32_t ulOption01;
	uint32_t ulOption02;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__MFIncCounterSetFIFO0Level(modbus,ulMFModuleIndex,ulFIFOLevel,ulOption01,ulOption02,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__MFIncCounterSetFIFO0Level");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__MFIncCounterSetFIFO0Level\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__MFIncCounterSetFIFO0Level()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__MFIncCounterSetFIFO0Level OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__MFIncCounterSetFIFO0Level(struct modbus * modbus,
	uint32_t ulMFModuleIndex,
	uint32_t ulFIFOLevel,
	uint32_t ulOption01,
	uint32_t ulOption02
, struct GetLastCommandStatus_parameters_t * CommandStatus);

/** Write all digital i/o channels value. if the channel is define as input, nothing append on this channel.
*
* <h3>For new application(s) or automat communication is it recommended tu use the function MSXE17xx__DigitalIOWriteAllChannelsValue.</h3>
*
* <ul>
* @param[in] <li> <b>ulValue</b> : Channels value
* </ul>
* @param[out] <li><b>Possible return value on the remote system:</b>\n
* <ul>
*                            <li>  0: means the remote function performed OK \n
*                            <li> -1: means an system error occured \n
*                            <li> -100: Write digital I/O kernel function error \n
* </ul>
*/

/*
@return 0 on success, -1 on system error, -2 on MODBUS exception (the exception code is in modbus->exception), -3 if response from remote system is incorrect, -4 if the remote call generated a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed
*/

/* Below is an example on how this function is intended to be used

int sample_MSXE170x__DigitalIOWriteAllChannelsValue(struct modbus * modbus)
{

	//variables declaration

	struct GetLastCommandStatus_parameters_t CommandStatus;
	int ret = 0;
	uint32_t ulValue;

	//Initialise variables here

	//Remote function call
	ret = modbus_call_MSXE170x__DigitalIOWriteAllChannelsValue(modbus,ulValue,&CommandStatus);

	//Return value check
	switch(ret)
	{
		case 0: // OK
			break;
		case -1: // system error
			perror("MSXE170x__DigitalIOWriteAllChannelsValue");
			return -1;
			break;
		case -2: // MODBUS exception
			switch(modbus->exception)
			{
				case MODBUS_REMOTE_EXECUTION_ERROR: // actually a remote exception error and we get it in CommandStatus
					printf("Remote command returned: %d\n",MODBUS_NTOHL((int) (CommandStatus.ReturnValue)) );
					*(CommandStatus.Errstr+sizeof(CommandStatus.Errstr)-1)='\0';
					printf("Remote errno: %d (%s)\n",(int)MODBUS_NTOHL((int)CommandStatus.Syserrno),CommandStatus.Errstr);
					return -1;
					break;
				default:
					printf("remote system returned a MODBUS exception for command MSXE170x__DigitalIOWriteAllChannelsValue\n");
					printf("reason: %s (%d)\n",modbus_exception_to_str(modbus->exception),modbus->exception);
					return -1;
					break;
			}
			break;
		case -3: // incorrect response from remote system
			printf("incorrect response from remote system\n");
			return -1;
			break;
		case -4: 
			printf("remote system returned a MODBUS_REMOTE_EXECUTION_ERROR exception but call to GetLastCommandStatus() failed\n");
			return -1;
			break;
		default: 
			printf("unknown return code %d from MSXE170x__DigitalIOWriteAllChannelsValue()\n",ret);
			return -1;
			break;
	}
	printf("call to MSXE170x__DigitalIOWriteAllChannelsValue OK\n");
	return 0;
}

*/

int modbus_call_MSXE170x__DigitalIOWriteAllChannelsValue(struct modbus * modbus,
	uint32_t ulValue
, struct GetLastCommandStatus_parameters_t * CommandStatus);

#endif //_MODBUS_MSXE170X_CLIENT_DEFINITION_H_


