using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDISocket;
using System.Text.RegularExpressions;

namespace CyclicAcquisitionHWTriggerGate
{
	/// <summary>
	/// Zusammenfassung fr CyclicAcquisition.
	/// </summary>
    public class CyclicAcquisitionHWTriggerGate : System.Windows.Forms.Form
    {
        private System.Windows.Forms.GroupBox descriptionGroupBox;
        private GroupBox counterConfigGroupBox;
        private CheckBox counter3Label;
        private CheckBox counter2Label;
        private CheckBox counter1Label;
        private CheckBox counter0Label;
        private GroupBox helpGroupBox;
        private GroupBox acquisitionConfigurationGroupBox;
        private TextBox FIFOSizeTextbox;
        private Button counterInitialisationButton;
        private Button clearCounterButton;
        private Button startCounterAcquisitionButton;
        private Button stopCounterAcquisitionButton;
        private Button counterReleaseInitialisationButton;
        private GroupBox acquisitionInformationGroupBox;
        internal TextBox valuesTextbox;
        private System.Windows.Forms.Timer DisplayTimer;
        private GroupBox moduleSelectionGroupBox;
        private Button connectButton;
        private Label minus2Label;
        private Label minus1Label;
        private TextBox IP3Textbox;
        private TextBox IP2Textbox;
        private TextBox IP1Textbox;
        private TextBox IP0Textbox;
        private ComboBox counterModeComboBox;
        private CheckBox gateCounter3CheckBox;
        private CheckBox gateCounter2CheckBox;
        private CheckBox gateCounter1CheckBox;
        private CheckBox gateCounter0CheckBox;
        private Button disableGateButton;
        private Button enableGateButton;
        private GroupBox acquisitionControlsGroupBox;
        private Label modeSelectionLabel;
        private GroupBox counterControlsGroupBox;
        private Label MSXEInfoLabel;
        private System.ComponentModel.IContainer components;

        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string strItem, long lValue)
            {

                this.myItem = strItem;
                this.myValue = lValue;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }

		public CyclicAcquisitionHWTriggerGate()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.Windows.Forms.Label descriptionLabel;
            System.Windows.Forms.Label triggerGateSelectionLabel;
            System.Windows.Forms.Label counterSelectionLabel;
            System.Windows.Forms.Label helpLabel;
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CyclicAcquisitionHWTriggerGate));
            System.Windows.Forms.Label FIFOsizeLabel;
            System.Windows.Forms.Label ipAddressLabel;
            System.Windows.Forms.Label minus0Label;
            this.modeSelectionLabel = new System.Windows.Forms.Label();
            this.descriptionGroupBox = new System.Windows.Forms.GroupBox();
            this.counterConfigGroupBox = new System.Windows.Forms.GroupBox();
            this.gateCounter3CheckBox = new System.Windows.Forms.CheckBox();
            this.gateCounter2CheckBox = new System.Windows.Forms.CheckBox();
            this.gateCounter1CheckBox = new System.Windows.Forms.CheckBox();
            this.gateCounter0CheckBox = new System.Windows.Forms.CheckBox();
            this.counter3Label = new System.Windows.Forms.CheckBox();
            this.counter2Label = new System.Windows.Forms.CheckBox();
            this.counter1Label = new System.Windows.Forms.CheckBox();
            this.counter0Label = new System.Windows.Forms.CheckBox();
            this.counterModeComboBox = new System.Windows.Forms.ComboBox();
            this.helpGroupBox = new System.Windows.Forms.GroupBox();
            this.acquisitionConfigurationGroupBox = new System.Windows.Forms.GroupBox();
            this.FIFOSizeTextbox = new System.Windows.Forms.TextBox();
            this.counterInitialisationButton = new System.Windows.Forms.Button();
            this.clearCounterButton = new System.Windows.Forms.Button();
            this.startCounterAcquisitionButton = new System.Windows.Forms.Button();
            this.stopCounterAcquisitionButton = new System.Windows.Forms.Button();
            this.counterReleaseInitialisationButton = new System.Windows.Forms.Button();
            this.acquisitionInformationGroupBox = new System.Windows.Forms.GroupBox();
            this.valuesTextbox = new System.Windows.Forms.TextBox();
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.moduleSelectionGroupBox = new System.Windows.Forms.GroupBox();
            this.connectButton = new System.Windows.Forms.Button();
            this.minus2Label = new System.Windows.Forms.Label();
            this.minus1Label = new System.Windows.Forms.Label();
            this.IP3Textbox = new System.Windows.Forms.TextBox();
            this.IP2Textbox = new System.Windows.Forms.TextBox();
            this.IP1Textbox = new System.Windows.Forms.TextBox();
            this.IP0Textbox = new System.Windows.Forms.TextBox();
            this.disableGateButton = new System.Windows.Forms.Button();
            this.enableGateButton = new System.Windows.Forms.Button();
            this.acquisitionControlsGroupBox = new System.Windows.Forms.GroupBox();
            this.counterControlsGroupBox = new System.Windows.Forms.GroupBox();
            this.MSXEInfoLabel = new System.Windows.Forms.Label();
            descriptionLabel = new System.Windows.Forms.Label();
            triggerGateSelectionLabel = new System.Windows.Forms.Label();
            counterSelectionLabel = new System.Windows.Forms.Label();
            helpLabel = new System.Windows.Forms.Label();
            FIFOsizeLabel = new System.Windows.Forms.Label();
            ipAddressLabel = new System.Windows.Forms.Label();
            minus0Label = new System.Windows.Forms.Label();
            this.descriptionGroupBox.SuspendLayout();
            this.counterConfigGroupBox.SuspendLayout();
            this.helpGroupBox.SuspendLayout();
            this.acquisitionConfigurationGroupBox.SuspendLayout();
            this.acquisitionInformationGroupBox.SuspendLayout();
            this.moduleSelectionGroupBox.SuspendLayout();
            this.acquisitionControlsGroupBox.SuspendLayout();
            this.counterControlsGroupBox.SuspendLayout();
            this.SuspendLayout();
            // 
            // descriptionLabel
            // 
            descriptionLabel.Location = new System.Drawing.Point(8, 16);
            descriptionLabel.Name = "descriptionLabel";
            descriptionLabel.Size = new System.Drawing.Size(914, 24);
            descriptionLabel.TabIndex = 0;
            descriptionLabel.Text = "This sample makes a cyclic acquisition from the counters with hardware trigger ga" +
                "te selection.";
            // 
            // triggerGateSelectionLabel
            // 
            triggerGateSelectionLabel.AutoSize = true;
            triggerGateSelectionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            triggerGateSelectionLabel.Location = new System.Drawing.Point(8, 45);
            triggerGateSelectionLabel.Name = "triggerGateSelectionLabel";
            triggerGateSelectionLabel.Size = new System.Drawing.Size(109, 13);
            triggerGateSelectionLabel.TabIndex = 54;
            triggerGateSelectionLabel.Text = "Trigger gate selection";
            // 
            // counterSelectionLabel
            // 
            counterSelectionLabel.AutoSize = true;
            counterSelectionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            counterSelectionLabel.Location = new System.Drawing.Point(8, 22);
            counterSelectionLabel.Name = "counterSelectionLabel";
            counterSelectionLabel.Size = new System.Drawing.Size(100, 13);
            counterSelectionLabel.TabIndex = 46;
            counterSelectionLabel.Text = "Counter(s) selection";
            // 
            // helpLabel
            // 
            helpLabel.Location = new System.Drawing.Point(8, 16);
            helpLabel.Name = "helpLabel";
            helpLabel.Size = new System.Drawing.Size(914, 98);
            helpLabel.TabIndex = 0;
            helpLabel.Text = resources.GetString("helpLabel.Text");
            // 
            // FIFOsizeLabel
            // 
            FIFOsizeLabel.AutoSize = true;
            FIFOsizeLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            FIFOsizeLabel.Location = new System.Drawing.Point(13, 23);
            FIFOsizeLabel.Name = "FIFOsizeLabel";
            FIFOsizeLabel.Size = new System.Drawing.Size(91, 13);
            FIFOsizeLabel.TabIndex = 88;
            FIFOsizeLabel.Text = "Counter FIFO size";
            // 
            // ipAddressLabel
            // 
            ipAddressLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            ipAddressLabel.Location = new System.Drawing.Point(8, 27);
            ipAddressLabel.Name = "ipAddressLabel";
            ipAddressLabel.Size = new System.Drawing.Size(208, 16);
            ipAddressLabel.TabIndex = 98;
            ipAddressLabel.Text = "IP address of the MSX-E170x module :";
            // 
            // modeSelectionLabel
            // 
            this.modeSelectionLabel.AutoSize = true;
            this.modeSelectionLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.modeSelectionLabel.Location = new System.Drawing.Point(8, 68);
            this.modeSelectionLabel.Name = "modeSelectionLabel";
            this.modeSelectionLabel.Size = new System.Drawing.Size(34, 13);
            this.modeSelectionLabel.TabIndex = 46;
            this.modeSelectionLabel.Text = "Mode";
            // 
            // descriptionGroupBox
            // 
            this.descriptionGroupBox.Controls.Add(descriptionLabel);
            this.descriptionGroupBox.Location = new System.Drawing.Point(8, 8);
            this.descriptionGroupBox.Name = "descriptionGroupBox";
            this.descriptionGroupBox.Size = new System.Drawing.Size(938, 48);
            this.descriptionGroupBox.TabIndex = 10;
            this.descriptionGroupBox.TabStop = false;
            this.descriptionGroupBox.Text = "Description";
            // 
            // counterConfigGroupBox
            // 
            this.counterConfigGroupBox.Controls.Add(this.gateCounter3CheckBox);
            this.counterConfigGroupBox.Controls.Add(this.gateCounter2CheckBox);
            this.counterConfigGroupBox.Controls.Add(this.gateCounter1CheckBox);
            this.counterConfigGroupBox.Controls.Add(this.gateCounter0CheckBox);
            this.counterConfigGroupBox.Controls.Add(triggerGateSelectionLabel);
            this.counterConfigGroupBox.Controls.Add(this.counter3Label);
            this.counterConfigGroupBox.Controls.Add(this.counter2Label);
            this.counterConfigGroupBox.Controls.Add(this.counter1Label);
            this.counterConfigGroupBox.Controls.Add(this.counter0Label);
            this.counterConfigGroupBox.Controls.Add(counterSelectionLabel);
            this.counterConfigGroupBox.Controls.Add(this.modeSelectionLabel);
            this.counterConfigGroupBox.Controls.Add(this.counterModeComboBox);
            this.counterConfigGroupBox.Location = new System.Drawing.Point(12, 247);
            this.counterConfigGroupBox.Name = "counterConfigGroupBox";
            this.counterConfigGroupBox.Size = new System.Drawing.Size(385, 94);
            this.counterConfigGroupBox.TabIndex = 76;
            this.counterConfigGroupBox.TabStop = false;
            this.counterConfigGroupBox.Text = "Counter(s) configuration";
            // 
            // gateCounter3CheckBox
            // 
            this.gateCounter3CheckBox.AutoSize = true;
            this.gateCounter3CheckBox.Checked = true;
            this.gateCounter3CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter3CheckBox.Location = new System.Drawing.Point(344, 45);
            this.gateCounter3CheckBox.Name = "gateCounter3CheckBox";
            this.gateCounter3CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter3CheckBox.TabIndex = 53;
            this.gateCounter3CheckBox.UseVisualStyleBackColor = true;
            // 
            // gateCounter2CheckBox
            // 
            this.gateCounter2CheckBox.AutoSize = true;
            this.gateCounter2CheckBox.Checked = true;
            this.gateCounter2CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter2CheckBox.Location = new System.Drawing.Point(306, 45);
            this.gateCounter2CheckBox.Name = "gateCounter2CheckBox";
            this.gateCounter2CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter2CheckBox.TabIndex = 52;
            this.gateCounter2CheckBox.UseVisualStyleBackColor = true;
            // 
            // gateCounter1CheckBox
            // 
            this.gateCounter1CheckBox.AutoSize = true;
            this.gateCounter1CheckBox.Checked = true;
            this.gateCounter1CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter1CheckBox.Location = new System.Drawing.Point(268, 45);
            this.gateCounter1CheckBox.Name = "gateCounter1CheckBox";
            this.gateCounter1CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter1CheckBox.TabIndex = 51;
            this.gateCounter1CheckBox.UseVisualStyleBackColor = true;
            // 
            // gateCounter0CheckBox
            // 
            this.gateCounter0CheckBox.AutoSize = true;
            this.gateCounter0CheckBox.Checked = true;
            this.gateCounter0CheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.gateCounter0CheckBox.Location = new System.Drawing.Point(230, 45);
            this.gateCounter0CheckBox.Name = "gateCounter0CheckBox";
            this.gateCounter0CheckBox.Size = new System.Drawing.Size(15, 14);
            this.gateCounter0CheckBox.TabIndex = 50;
            this.gateCounter0CheckBox.UseVisualStyleBackColor = true;
            // 
            // counter3Label
            // 
            this.counter3Label.AutoSize = true;
            this.counter3Label.Checked = true;
            this.counter3Label.CheckState = System.Windows.Forms.CheckState.Checked;
            this.counter3Label.Location = new System.Drawing.Point(344, 22);
            this.counter3Label.Name = "counter3Label";
            this.counter3Label.Size = new System.Drawing.Size(32, 17);
            this.counter3Label.TabIndex = 7;
            this.counter3Label.Text = "3";
            this.counter3Label.UseVisualStyleBackColor = true;
            this.counter3Label.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // counter2Label
            // 
            this.counter2Label.AutoSize = true;
            this.counter2Label.Checked = true;
            this.counter2Label.CheckState = System.Windows.Forms.CheckState.Checked;
            this.counter2Label.Location = new System.Drawing.Point(306, 22);
            this.counter2Label.Name = "counter2Label";
            this.counter2Label.Size = new System.Drawing.Size(32, 17);
            this.counter2Label.TabIndex = 6;
            this.counter2Label.Text = "2";
            this.counter2Label.UseVisualStyleBackColor = true;
            this.counter2Label.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // counter1Label
            // 
            this.counter1Label.AutoSize = true;
            this.counter1Label.Checked = true;
            this.counter1Label.CheckState = System.Windows.Forms.CheckState.Checked;
            this.counter1Label.Location = new System.Drawing.Point(268, 22);
            this.counter1Label.Name = "counter1Label";
            this.counter1Label.Size = new System.Drawing.Size(32, 17);
            this.counter1Label.TabIndex = 5;
            this.counter1Label.Text = "1";
            this.counter1Label.UseVisualStyleBackColor = true;
            this.counter1Label.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // counter0Label
            // 
            this.counter0Label.AutoSize = true;
            this.counter0Label.Checked = true;
            this.counter0Label.CheckState = System.Windows.Forms.CheckState.Checked;
            this.counter0Label.Location = new System.Drawing.Point(230, 22);
            this.counter0Label.Name = "counter0Label";
            this.counter0Label.Size = new System.Drawing.Size(32, 17);
            this.counter0Label.TabIndex = 4;
            this.counter0Label.Text = "0";
            this.counter0Label.UseVisualStyleBackColor = true;
            this.counter0Label.CheckedChanged += new System.EventHandler(this.CH_Counter_CheckedChanged);
            // 
            // counterModeComboBox
            // 
            this.counterModeComboBox.AllowDrop = true;
            this.counterModeComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.counterModeComboBox.FormattingEnabled = true;
            this.counterModeComboBox.Items.AddRange(new object[] {
            "DIRECT",
            "SIMPLE",
            "DOUBLE",
            "QUADRUPLE"});
            this.counterModeComboBox.Location = new System.Drawing.Point(230, 65);
            this.counterModeComboBox.Name = "counterModeComboBox";
            this.counterModeComboBox.Size = new System.Drawing.Size(129, 21);
            this.counterModeComboBox.TabIndex = 8;
            // 
            // helpGroupBox
            // 
            this.helpGroupBox.Controls.Add(helpLabel);
            this.helpGroupBox.Location = new System.Drawing.Point(8, 62);
            this.helpGroupBox.Name = "helpGroupBox";
            this.helpGroupBox.Size = new System.Drawing.Size(938, 115);
            this.helpGroupBox.TabIndex = 93;
            this.helpGroupBox.TabStop = false;
            this.helpGroupBox.Text = "Help";
            // 
            // acquisitionConfigurationGroupBox
            // 
            this.acquisitionConfigurationGroupBox.Controls.Add(this.FIFOSizeTextbox);
            this.acquisitionConfigurationGroupBox.Controls.Add(FIFOsizeLabel);
            this.acquisitionConfigurationGroupBox.Location = new System.Drawing.Point(12, 347);
            this.acquisitionConfigurationGroupBox.Name = "acquisitionConfigurationGroupBox";
            this.acquisitionConfigurationGroupBox.Size = new System.Drawing.Size(385, 49);
            this.acquisitionConfigurationGroupBox.TabIndex = 94;
            this.acquisitionConfigurationGroupBox.TabStop = false;
            this.acquisitionConfigurationGroupBox.Text = "Acquisition configuration";
            // 
            // FIFOSizeTextbox
            // 
            this.FIFOSizeTextbox.Location = new System.Drawing.Point(230, 20);
            this.FIFOSizeTextbox.Name = "FIFOSizeTextbox";
            this.FIFOSizeTextbox.Size = new System.Drawing.Size(130, 20);
            this.FIFOSizeTextbox.TabIndex = 11;
            this.FIFOSizeTextbox.Text = "1";
            // 
            // counterInitialisationButton
            // 
            this.counterInitialisationButton.Enabled = false;
            this.counterInitialisationButton.Location = new System.Drawing.Point(13, 19);
            this.counterInitialisationButton.Name = "counterInitialisationButton";
            this.counterInitialisationButton.Size = new System.Drawing.Size(518, 24);
            this.counterInitialisationButton.TabIndex = 14;
            this.counterInitialisationButton.Text = "Counter(s) initialisation";
            this.counterInitialisationButton.UseVisualStyleBackColor = true;
            this.counterInitialisationButton.Click += new System.EventHandler(this.B_CounterInitialisation_Click);
            // 
            // clearCounterButton
            // 
            this.clearCounterButton.Enabled = false;
            this.clearCounterButton.Location = new System.Drawing.Point(274, 62);
            this.clearCounterButton.Name = "clearCounterButton";
            this.clearCounterButton.Size = new System.Drawing.Size(257, 24);
            this.clearCounterButton.TabIndex = 16;
            this.clearCounterButton.Text = "Clear counter(s)";
            this.clearCounterButton.UseVisualStyleBackColor = true;
            this.clearCounterButton.Click += new System.EventHandler(this.B_ClearCounter_Click);
            // 
            // startCounterAcquisitionButton
            // 
            this.startCounterAcquisitionButton.Enabled = false;
            this.startCounterAcquisitionButton.Location = new System.Drawing.Point(379, 19);
            this.startCounterAcquisitionButton.Name = "startCounterAcquisitionButton";
            this.startCounterAcquisitionButton.Size = new System.Drawing.Size(152, 24);
            this.startCounterAcquisitionButton.TabIndex = 19;
            this.startCounterAcquisitionButton.Text = "Start cyclic acquisition";
            this.startCounterAcquisitionButton.UseVisualStyleBackColor = true;
            this.startCounterAcquisitionButton.Click += new System.EventHandler(this.B_StartCounterAcquisition_Click);
            // 
            // stopCounterAcquisitionButton
            // 
            this.stopCounterAcquisitionButton.Enabled = false;
            this.stopCounterAcquisitionButton.Location = new System.Drawing.Point(221, 19);
            this.stopCounterAcquisitionButton.Name = "stopCounterAcquisitionButton";
            this.stopCounterAcquisitionButton.Size = new System.Drawing.Size(152, 24);
            this.stopCounterAcquisitionButton.TabIndex = 20;
            this.stopCounterAcquisitionButton.Text = "Stop cyclic acquisition";
            this.stopCounterAcquisitionButton.UseVisualStyleBackColor = true;
            this.stopCounterAcquisitionButton.Click += new System.EventHandler(this.B_StopCounterAcquisition_Click);
            // 
            // counterReleaseInitialisationButton
            // 
            this.counterReleaseInitialisationButton.Enabled = false;
            this.counterReleaseInitialisationButton.Location = new System.Drawing.Point(13, 62);
            this.counterReleaseInitialisationButton.Name = "counterReleaseInitialisationButton";
            this.counterReleaseInitialisationButton.Size = new System.Drawing.Size(257, 24);
            this.counterReleaseInitialisationButton.TabIndex = 15;
            this.counterReleaseInitialisationButton.Text = "Release counter(s) initialisation";
            this.counterReleaseInitialisationButton.UseVisualStyleBackColor = true;
            this.counterReleaseInitialisationButton.Click += new System.EventHandler(this.B_CounterReleaseInitialisation_Click);
            // 
            // acquisitionInformationGroupBox
            // 
            this.acquisitionInformationGroupBox.Controls.Add(this.valuesTextbox);
            this.acquisitionInformationGroupBox.Location = new System.Drawing.Point(12, 402);
            this.acquisitionInformationGroupBox.Name = "acquisitionInformationGroupBox";
            this.acquisitionInformationGroupBox.Size = new System.Drawing.Size(934, 138);
            this.acquisitionInformationGroupBox.TabIndex = 99;
            this.acquisitionInformationGroupBox.TabStop = false;
            this.acquisitionInformationGroupBox.Text = "Acquisition information";
            // 
            // valuesTextbox
            // 
            this.valuesTextbox.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.valuesTextbox.Location = new System.Drawing.Point(11, 19);
            this.valuesTextbox.Multiline = true;
            this.valuesTextbox.Name = "valuesTextbox";
            this.valuesTextbox.ReadOnly = true;
            this.valuesTextbox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.valuesTextbox.Size = new System.Drawing.Size(917, 107);
            this.valuesTextbox.TabIndex = 140;
            this.valuesTextbox.TabStop = false;
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // moduleSelectionGroupBox
            // 
            this.moduleSelectionGroupBox.Controls.Add(this.MSXEInfoLabel);
            this.moduleSelectionGroupBox.Controls.Add(this.connectButton);
            this.moduleSelectionGroupBox.Controls.Add(this.minus2Label);
            this.moduleSelectionGroupBox.Controls.Add(this.minus1Label);
            this.moduleSelectionGroupBox.Controls.Add(minus0Label);
            this.moduleSelectionGroupBox.Controls.Add(this.IP3Textbox);
            this.moduleSelectionGroupBox.Controls.Add(this.IP2Textbox);
            this.moduleSelectionGroupBox.Controls.Add(this.IP1Textbox);
            this.moduleSelectionGroupBox.Controls.Add(this.IP0Textbox);
            this.moduleSelectionGroupBox.Controls.Add(ipAddressLabel);
            this.moduleSelectionGroupBox.Location = new System.Drawing.Point(12, 183);
            this.moduleSelectionGroupBox.Name = "moduleSelectionGroupBox";
            this.moduleSelectionGroupBox.Size = new System.Drawing.Size(934, 58);
            this.moduleSelectionGroupBox.TabIndex = 100;
            this.moduleSelectionGroupBox.TabStop = false;
            this.moduleSelectionGroupBox.Text = "Module selection";
            // 
            // connectButton
            // 
            this.connectButton.Location = new System.Drawing.Point(406, 20);
            this.connectButton.Name = "connectButton";
            this.connectButton.Size = new System.Drawing.Size(91, 29);
            this.connectButton.TabIndex = 97;
            this.connectButton.Text = "Connect";
            this.connectButton.UseVisualStyleBackColor = true;
            this.connectButton.Click += new System.EventHandler(this.B_Connect_Click);
            // 
            // minus2Label
            // 
            this.minus2Label.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.minus2Label.Location = new System.Drawing.Point(352, 25);
            this.minus2Label.Name = "minus2Label";
            this.minus2Label.Size = new System.Drawing.Size(8, 16);
            this.minus2Label.TabIndex = 101;
            this.minus2Label.Text = "-";
            // 
            // minus1Label
            // 
            this.minus1Label.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.minus1Label.Location = new System.Drawing.Point(296, 25);
            this.minus1Label.Name = "minus1Label";
            this.minus1Label.Size = new System.Drawing.Size(8, 16);
            this.minus1Label.TabIndex = 100;
            this.minus1Label.Text = "-";
            // 
            // minus0Label
            // 
            minus0Label.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            minus0Label.Location = new System.Drawing.Point(240, 25);
            minus0Label.Name = "minus0Label";
            minus0Label.Size = new System.Drawing.Size(8, 16);
            minus0Label.TabIndex = 99;
            minus0Label.Text = "-";
            // 
            // IP3Textbox
            // 
            this.IP3Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP3Textbox.Location = new System.Drawing.Point(368, 25);
            this.IP3Textbox.MaxLength = 3;
            this.IP3Textbox.Name = "IP3Textbox";
            this.IP3Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP3Textbox.TabIndex = 96;
            // 
            // IP2Textbox
            // 
            this.IP2Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP2Textbox.Location = new System.Drawing.Point(312, 25);
            this.IP2Textbox.MaxLength = 3;
            this.IP2Textbox.Name = "IP2Textbox";
            this.IP2Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP2Textbox.TabIndex = 95;
            // 
            // IP1Textbox
            // 
            this.IP1Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP1Textbox.Location = new System.Drawing.Point(256, 25);
            this.IP1Textbox.MaxLength = 3;
            this.IP1Textbox.Name = "IP1Textbox";
            this.IP1Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP1Textbox.TabIndex = 94;
            // 
            // IP0Textbox
            // 
            this.IP0Textbox.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.IP0Textbox.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.IP0Textbox.Location = new System.Drawing.Point(200, 25);
            this.IP0Textbox.MaxLength = 3;
            this.IP0Textbox.Name = "IP0Textbox";
            this.IP0Textbox.Size = new System.Drawing.Size(32, 20);
            this.IP0Textbox.TabIndex = 93;
            // 
            // disableGateButton
            // 
            this.disableGateButton.Enabled = false;
            this.disableGateButton.Location = new System.Drawing.Point(13, 19);
            this.disableGateButton.Name = "disableGateButton";
            this.disableGateButton.Size = new System.Drawing.Size(93, 24);
            this.disableGateButton.TabIndex = 20;
            this.disableGateButton.Text = "Disable gate";
            this.disableGateButton.UseVisualStyleBackColor = true;
            this.disableGateButton.Click += new System.EventHandler(this.enableDisableGateButton_Click);
            // 
            // enableGateButton
            // 
            this.enableGateButton.Enabled = false;
            this.enableGateButton.Location = new System.Drawing.Point(112, 19);
            this.enableGateButton.Name = "enableGateButton";
            this.enableGateButton.Size = new System.Drawing.Size(93, 24);
            this.enableGateButton.TabIndex = 20;
            this.enableGateButton.Text = "Enable gate";
            this.enableGateButton.UseVisualStyleBackColor = true;
            this.enableGateButton.Click += new System.EventHandler(this.enableDisableGateButton_Click);
            // 
            // acquisitionControlsGroupBox
            // 
            this.acquisitionControlsGroupBox.Controls.Add(this.enableGateButton);
            this.acquisitionControlsGroupBox.Controls.Add(this.startCounterAcquisitionButton);
            this.acquisitionControlsGroupBox.Controls.Add(this.stopCounterAcquisitionButton);
            this.acquisitionControlsGroupBox.Controls.Add(this.disableGateButton);
            this.acquisitionControlsGroupBox.Location = new System.Drawing.Point(403, 347);
            this.acquisitionControlsGroupBox.Name = "acquisitionControlsGroupBox";
            this.acquisitionControlsGroupBox.Size = new System.Drawing.Size(543, 49);
            this.acquisitionControlsGroupBox.TabIndex = 101;
            this.acquisitionControlsGroupBox.TabStop = false;
            this.acquisitionControlsGroupBox.Text = "Acquisition controls";
            // 
            // counterControlsGroupBox
            // 
            this.counterControlsGroupBox.Controls.Add(this.clearCounterButton);
            this.counterControlsGroupBox.Controls.Add(this.counterInitialisationButton);
            this.counterControlsGroupBox.Controls.Add(this.counterReleaseInitialisationButton);
            this.counterControlsGroupBox.Location = new System.Drawing.Point(403, 247);
            this.counterControlsGroupBox.Name = "counterControlsGroupBox";
            this.counterControlsGroupBox.Size = new System.Drawing.Size(543, 94);
            this.counterControlsGroupBox.TabIndex = 102;
            this.counterControlsGroupBox.TabStop = false;
            this.counterControlsGroupBox.Text = "Counter controls";
            // 
            // MSXEInfoLabel
            // 
            this.MSXEInfoLabel.Location = new System.Drawing.Point(503, 13);
            this.MSXEInfoLabel.Name = "MSXEInfoLabel";
            this.MSXEInfoLabel.Size = new System.Drawing.Size(419, 36);
            this.MSXEInfoLabel.TabIndex = 102;
            this.MSXEInfoLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // CyclicAcquisitionHWTriggerGate
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(954, 544);
            this.Controls.Add(this.counterControlsGroupBox);
            this.Controls.Add(this.acquisitionControlsGroupBox);
            this.Controls.Add(this.moduleSelectionGroupBox);
            this.Controls.Add(this.acquisitionConfigurationGroupBox);
            this.Controls.Add(this.acquisitionInformationGroupBox);
            this.Controls.Add(this.helpGroupBox);
            this.Controls.Add(this.counterConfigGroupBox);
            this.Controls.Add(this.descriptionGroupBox);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "CyclicAcquisitionHWTriggerGate";
            this.Text = "C# Counter(s) cyclic acquisition with Hardware Trigger Gate";
            this.Load += new System.EventHandler(this.CyclicAcquisitionHWTriggerGate_Load);
            this.Closed += new System.EventHandler(this.CyclicAcquisitionHWTriggerGate_Closed);
            this.FormClosed += new System.Windows.Forms.FormClosedEventHandler(this.CyclicAcquisitionHWTriggerGate_FormClosed);
            this.descriptionGroupBox.ResumeLayout(false);
            this.counterConfigGroupBox.ResumeLayout(false);
            this.counterConfigGroupBox.PerformLayout();
            this.helpGroupBox.ResumeLayout(false);
            this.acquisitionConfigurationGroupBox.ResumeLayout(false);
            this.acquisitionConfigurationGroupBox.PerformLayout();
            this.acquisitionInformationGroupBox.ResumeLayout(false);
            this.acquisitionInformationGroupBox.PerformLayout();
            this.moduleSelectionGroupBox.ResumeLayout(false);
            this.moduleSelectionGroupBox.PerformLayout();
            this.acquisitionControlsGroupBox.ResumeLayout(false);
            this.counterControlsGroupBox.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
            Application.Run(new CyclicAcquisitionHWTriggerGate());
		}

        public static String ConvertFromTime_T(byte[] bBuffer, int iIndex)
        {
            ulong ulTimeStampLow = BitConverter.ToUInt32(bBuffer, iIndex);
            ulong ulTimeStampHigh = BitConverter.ToUInt32(bBuffer, iIndex + 4);

            return (ConvertFromTime_T(ulTimeStampHigh, ulTimeStampLow));
        }

        public static String ConvertFromTime_T(ulong ulTimeStampHigh, ulong ulTimeStampLow)
        {
            ulong ulTimeStampLowms = (ulong)(ulTimeStampLow / 1000);
            ulong ulTimeStampLowmus = (ulong)(ulTimeStampLow % 1000);

            DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
            long tickTotal = dt70.Ticks + (long)(ulTimeStampHigh * 10000000L);
            DateTime netTimeT = new DateTime(tickTotal);
            return (netTimeT.ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3"));
        }
        
        
        // Global Variable
		MXCommon_WebReference.MXCommon MX_Common;
		MSXE170x_WebReference.MSXE17xx MSXE17xx;
        Socket                         SocketClient = null;
        String                         DisplayText = "";
        AsyncClientStream              Client = null;
        CheckBox[]                     CounterList;
        int                            Counters = 0;
        byte                           bValueFormat = 0;

        private void CyclicAcquisitionHWTriggerGate_Load(object sender, System.EventArgs e)
		{
			MX_Common = new MXCommon_WebReference.MXCommon();
            MSXE17xx  = new MSXE170x_WebReference.MSXE17xx();
			MX_Common.Timeout = 2000;
            MSXE17xx.Timeout = 2000;

            IP0Textbox.Text = Properties.Settings.Default.IP0Textbox;
            IP1Textbox.Text = Properties.Settings.Default.IP1Textbox;
            IP2Textbox.Text = Properties.Settings.Default.IP2Textbox;
            IP3Textbox.Text = Properties.Settings.Default.IP3Textbox;

            counterModeComboBox.SelectedIndex = 0;

            // Counter list initialisation
            CounterList = new CheckBox[4];
            CounterList[0] = counter0Label;
            CounterList[1] = counter1Label;
            CounterList[2] = counter2Label;
            CounterList[3] = counter3Label;
        }


        private void CyclicAcquisitionHWTriggerGate_Closed(object sender, System.EventArgs e)
		{
            CloseAll();

            if (MSXE17xx != null)
                MSXE17xx = null;

			if (MX_Common != null)
				MX_Common = null;

			System.GC.Collect();
		}

        private void CloseAll ()
        {
            // Test if any acquisition in progress
            if (stopCounterAcquisitionButton.Enabled == true)
                B_StopCounterAcquisition_Click(null, null);

            // Test if counter initialised
            if (counterReleaseInitialisationButton.Enabled == true)
                B_CounterReleaseInitialisation_Click(null, null);
        }

        private void B_Connect_Click(object sender, EventArgs e)
        {
            byte[] bModuleType = new byte[200];
            System.Text.ASCIIEncoding ASCIIEnc = new System.Text.ASCIIEncoding();

            try
            {
                if ((Convert.ToUInt64(IP0Textbox.Text.ToString(), 10) >= 256) ||
                    (Convert.ToUInt64(IP0Textbox.Text.ToString(), 10) >= 256) ||
                    (Convert.ToUInt64(IP0Textbox.Text.ToString(), 10) >= 256) ||
                    (Convert.ToUInt64(IP0Textbox.Text.ToString(), 10) >= 256))
                    throw new Exception("The IP address you enter is not valid");

                MSXE17xx.Url = "http://" + IP0Textbox.Text + "." + IP1Textbox.Text + "." + IP2Textbox.Text + "." + IP3Textbox.Text + ":5555";
                MX_Common.Url = MSXE17xx.Url;

                // Get the module type
                MX_Common.GetModuleType(out bModuleType);
                MSXEInfoLabel.Text = ASCIIEnc.GetString(bModuleType);

                // Button initialisation
                counterInitialisationButton.Enabled = true;
                counterReleaseInitialisationButton.Enabled = false;
                clearCounterButton.Enabled = false;
                startCounterAcquisitionButton.Enabled = false;
                stopCounterAcquisitionButton.Enabled = false;
                counterConfigGroupBox.Enabled = true;
                acquisitionConfigurationGroupBox.Enabled = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_CounterInitialisation_Click(object sender, EventArgs e)
        {
            int  syserrno                 = 0;
            bool atLeastOneSensorSelected = false;

            try
            {
                // Counter(s) initialisation
                for (ulong i = 0; i < 4; i++)
                {
                    // Test if counter used
                    if (CounterList[i].Checked != true)
                        continue;

                    atLeastOneSensorSelected = true;

                    // Init the counter
                    int returnValue = MSXE17xx.MFIncCounterInit(i,
                                                                (ulong)counterModeComboBox.SelectedIndex, // Quadruple
                                                                0,
                                                                0,
                                                                0,
                                                                0,
                                                                0,
                                                                out syserrno);

                    if (returnValue != 0)
                        throw new Exception("MFIncCounterInit Error : " + returnValue.ToString());
                }

                if (atLeastOneSensorSelected == false)
                    throw new Exception("No counter(s) selected");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
                return;
            }

            // Button initialisation
            counterInitialisationButton.Enabled = false;
            counterReleaseInitialisationButton.Enabled = true;
            clearCounterButton.Enabled = true;
            startCounterAcquisitionButton.Enabled = true;
            stopCounterAcquisitionButton.Enabled = false;
            enableGateButton.Enabled = false;
            disableGateButton.Enabled = false;
            counterConfigGroupBox.Enabled = false;
            acquisitionConfigurationGroupBox.Enabled = true;
        }

        private void B_CounterReleaseInitialisation_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Counter(s) release
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked != true)
                    continue;

                // Release the counter initialisation
                RetValue = MSXE17xx.MFIncCounterRelease(i, out syserno);
                if (RetValue != 0)
                    MessageBox.Show("Counter " + i.ToString() + " MFIncCounterRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            // Button initialisation
            counterInitialisationButton.Enabled = true;
            counterReleaseInitialisationButton.Enabled = false;
            clearCounterButton.Enabled = false;
            startCounterAcquisitionButton.Enabled = false;
            stopCounterAcquisitionButton.Enabled = false;
            counterConfigGroupBox.Enabled = true;
            acquisitionConfigurationGroupBox.Enabled = true;
            enableGateButton.Enabled = false;
            disableGateButton.Enabled = false;
        }

        private void B_ClearCounter_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Clear counter(s)
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterList[i].Checked != true)
                    continue;

                // Clear the counter 
                RetValue = MSXE17xx.MFIncCounterClear(i, out syserno);
                if (RetValue != 0)
                    MessageBox.Show("MFIncCounterClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_StartCounterAcquisition_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;
            Thread ClientThread = null;

            // Test the FIFO size
            try
            {
                ulong FIFOSize = Convert.ToUInt32(FIFOSizeTextbox.Text);
                if (FIFOSize < 1 && FIFOSize > 200)
                    throw new Exception("Number of read sequence to acquire not OK");

                releaseDataServerConnection();

                // Create the client stream
                Client = new AddiData.ADDISocket.AsyncClientStream();

                // Open the socket connection to receive the data
                SocketClient = null;
                SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
                SocketClient.ReceiveBufferSize = 1048576;
                SocketClient.Connect(IP0Textbox.Text + "." + IP1Textbox.Text + "." + IP2Textbox.Text + "." + IP3Textbox.Text, 8989);


                MSXE17xx.MFCommonEnableDisableTriggerGate(0, 0, 0, out syserno);
                
                Counters = 0;

                // Counter(s) synchro latch initialisation
                for (ulong i = 0; i < 4; i++)
                {
                    // Test if counter used
                    if (CounterList[i].Checked != true)
                        continue;
                    
                    Counters++;

                    // Counter FIFO initialisation
                    RetValue = MSXE17xx.MFCommonSetFIFO0Level(i, FIFOSize, 0, 0, 0, 0, out syserno);
                    if (RetValue != 0)
                        throw new Exception("MFCommonSetFIFO0Level Error : " + RetValue.ToString());

                    MSXE17xx.MFIncCounterDisableAndReleaseLatchRegister(i, 0, 0, out syserno);
                    RetValue = MSXE17xx.MFIncCounterInitAndEnableLatchRegister(i, 0, 1, 1, ((CheckBox)Controls.Find("gateCounter" + i + "CheckBox", true)[0]).Checked ? (ulong)1 : (ulong)0, out syserno);
                    if (RetValue != 0)
                        throw new Exception("MFIncCounterInitAndEnableLatchRegister Error : " + RetValue.ToString());
                }

                // Start the read socket and the user thread
                Client.SingleFramesSize = 5 * 4 * Counters;
                Client.NbrOfFrames = Convert.ToInt32(FIFOSize);
                Client.Start(SocketClient);
                ClientThread = new Thread(ClientThreadFct);
                DisplayText = "";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                releaseDataServerConnection();
                return;
            }

            // Start the display timer and read socket thread
            DisplayTimer.Enabled = true;
            ClientThread.Priority = ThreadPriority.Lowest;
            ClientThread.Start();

            // Button initialisation
            counterInitialisationButton.Enabled = false;
            counterReleaseInitialisationButton.Enabled = false;
            clearCounterButton.Enabled = true;
            startCounterAcquisitionButton.Enabled = false;
            stopCounterAcquisitionButton.Enabled = true;
            counterConfigGroupBox.Enabled = false;
            acquisitionConfigurationGroupBox.Enabled = false;
            enableGateButton.Enabled = true;
            disableGateButton.Enabled = false;
        }

        private void releaseDataServerConnection()
        {
            try
            {
                // Stop the data server 
                if (Client != null)
                {
                    Client.Stoop();
                    Client = null;
                }

                if (SocketClient != null)
                {
                    // Close the socket connection
                    SocketClient.Shutdown(SocketShutdown.Both);
                    SocketClient.Close();
                    SocketClient = null;
                }
                System.GC.Collect();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_StopCounterAcquisition_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            try
            {
                // Disable synchro latch from counter(s)
                for (ulong i = 0; i < 4; i++)
                {
                    // Test if counter used
                    if (CounterList[i].Checked != true)
                        continue;

                    // Disable the syncho latch
                    RetValue = MSXE17xx.MFIncCounterDisableAndReleaseLatchRegister(i, 0, 0, out syserno);
                    if (RetValue != 0)
                        MessageBox.Show("Counter " + i.ToString() + " MFIncCounterDisableAndReleaseLatchRegister Error : " + RetValue.ToString());
                }

                releaseDataServerConnection();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            // Button initialisation
            counterInitialisationButton.Enabled = false;
            counterReleaseInitialisationButton.Enabled = true;
            clearCounterButton.Enabled = true;
            startCounterAcquisitionButton.Enabled = true;
            stopCounterAcquisitionButton.Enabled = false;
            counterConfigGroupBox.Enabled = false;
            acquisitionConfigurationGroupBox.Enabled = true;
        }

        private void ClientThreadFct()
        {
            byte[] SocketData;
            int StreamCounter = 0;
            int Offset = 0;
            int Counter = 0;
            ulong Source = 0;
            ulong AcquisitionCounter = 0;
            String sOutString;
            Single fValue;

            while ((SocketData = Client.ReadData()) != null)
            {
                sOutString = "";
                Offset = 0;

                for (StreamCounter = 0; StreamCounter < Client.NbrOfFrames; StreamCounter++)
                {
                    for (Counter = 0; Counter < Counters; Counter++)
                    {
                        Offset = (StreamCounter + (Client.NbrOfFrames * Counter)) * 5 * 4;
                        // 
                        sOutString = sOutString + "Acquisition counter: " + AcquisitionCounter.ToString();

                        // Get the time stamp
                        sOutString = sOutString + " / Time stamp: " + ConvertFromTime_T(SocketData, Offset);
                        Offset = Offset + 8;

                        // Get the counter nbr
                        sOutString = sOutString + " / counter: " + (BitConverter.ToUInt32(SocketData, Offset) & 3).ToString();
                        Offset = Offset + 4;

                        // Get the source
                        Source = BitConverter.ToUInt32(SocketData, Offset);
                        sOutString = sOutString + " / source: " + (Source & 0x7FFFFFFFUL).ToString();
                        Offset = Offset + 4;

                        // Get the counter value
                        if (bValueFormat == 0)
                        {
                            sOutString = sOutString + " / value: " + BitConverter.ToUInt32(SocketData, Offset).ToString();
                        }
                        else
                        {
                            fValue = BitConverter.ToSingle(SocketData, Offset);

                            if (Math.Abs(fValue) < 0.0001)
                            {
                                if (Math.Abs(fValue) < 0.0000001)
                                    sOutString = sOutString + " / position: " + (fValue * 1000000.0).ToString("F3") + "nm";
                                else
                                    sOutString = sOutString + " / position: " + (fValue * 1000.0).ToString("F3") + "m";
                            }
                            else
                            {
                                sOutString = sOutString + " / position: " + fValue.ToString("F3") + "mm";
                            }
                        }

                        // Test if measure error occur
                        sOutString = sOutString + " / error: " + (Source >> 31).ToString() + Environment.NewLine;

                        AcquisitionCounter++;
                    }
                }

                DisplayText = DisplayText + sOutString;
            }
        }

        private void DisplayTimer_Tick(object sender, EventArgs e)
        {
            valuesTextbox.Text = DisplayText;
        }

        private void CH_Counter_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox checkBox = sender as CheckBox;
            ((CheckBox)Controls.Find("gateCounter" + Regex.Match(checkBox.Name, @"\d+").Value + "checkBox", true)[0]).Enabled = (checkBox.Checked) ? true : false;
        }

        private void enableDisableGateButton_Click(object sender, EventArgs e)
        {
            int syserrno;
            int returnValue = 0;

            try
            {
                if ((sender as Button).Name.Contains("enable"))
                    returnValue = MSXE17xx.MFCommonEnableDisableTriggerGate(1, 0, 0, out syserrno);
                else
                    returnValue = MSXE17xx.MFCommonEnableDisableTriggerGate(0, 0, 0, out syserrno);
                if ((returnValue != 0) || (syserrno != 0))
                    throw new Exception("MFCommonEnableDisableTrig gerGate error : " + returnValue.ToString() + ", syserrno " + syserrno.ToString());
            }
            catch (Exception ex)
            {
                MessageBox.Show("enableDisableGateButton_Click Exception : " + ex.Message);
                return;
            }

            if ((sender as Button).Name.Contains("enable"))
            {
                enableGateButton.Enabled = false;
                disableGateButton.Enabled = true;
            }
            else
            {
                enableGateButton.Enabled = true;
                disableGateButton.Enabled = false;
            }
        }

        private void CyclicAcquisitionHWTriggerGate_FormClosed(object sender, FormClosedEventArgs e)
        {
            Properties.Settings.Default.IP0Textbox = IP0Textbox.Text;
            Properties.Settings.Default.IP1Textbox = IP1Textbox.Text;
            Properties.Settings.Default.IP2Textbox = IP2Textbox.Text;
            Properties.Settings.Default.IP3Textbox = IP3Textbox.Text;

            Properties.Settings.Default.resolutionComboBox = counterModeComboBox.SelectedIndex;
            Properties.Settings.Default.Save();
        }
    }
}
