/** @file ABCDFilterActivation.c
* ABCDFilterActivation : MSXE-170x : Permit to activate / deactivate a filter on the inputs A,B,C,D for a selected multifunction sub module
* 
*
* @author C. Guinot
* @date 19.02.2007
* 
* @version  $LastChangedRevision$
* @version $LastChangedDate$
* 
* 
* @par LICENCE
* @verbatim
*  Copyright (C) 2004,2005  ADDI-DATA GmbH for the source code of this module.
*        
*        ADDI-DATA GmbH 
*        Airport Boulevard B210
*        D-77836 Rheinmnster Germany 
*        Tel: +49(0)7229/1847-0 
*        Fax: +49(0)7229/1847-200
*        http://www.addi-data-com 
*        info@addi-data.com 
*        
*
* @endverbatim   
*
* @par UPDATES                                                                                                          
* @verbatim                                                                                                             
*  Date      : - 
*  Author        : -
*  Description   : -
*                                                                                                                       
* @endverbatim     
*
*
*/ 

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>


#include "..\..\..\..\..\..\Interface_Library\MSXE170x.nsmap"
#include "..\..\..\UTIL\utility.h"




void main(void)
{
	INT i_Error = 0;
	struct soap *ps_SoapEnv = NULL;
	struct MXCommon__ByteArrayResponse  s_ByteArrayResponse;
	struct MSXE170x__Response Response;
	CHAR pc_IPAddressTemp[50];
	CHAR pc_IPAddress[50];
	CHAR pc_SOAPIPAddress[50];
	DWORD dw_Dummy = 0;
	INT i_ReturnValue = 0;
	BYTE b_Exit = 0;
	int i_key = 0;
	unsigned long  ulMFModuleIndex = 0;
	unsigned long  ulInputAFilterValue = 0;
	unsigned long  ulInputBFilterValue = 0;
	unsigned long  ulInputCFilterValue = 0;
	unsigned long  ulInputDFilterValue = 0;



	/****************************/
	/* Print sample information */
	/****************************/
	printf("+---------------------------------------------------+\n");
	printf("| MSX-E170x                                         |\n");
	printf("|  Permit to activate / deactivate a filter         |\n");
    printf("| on the inputs A,B,C,D for a selected multifunction|\n");
    printf("| sub module                                        |\n");
	printf("+---------------------------------------------------+\n");
	printf("| <ESC> exit sample                                 |\n");
	printf("+---------------------------------------------------+\n");
	printf("\n");

	/* Initialise the SOAP connection */
	if (i_SOAP_Init(&ps_SoapEnv) == 0)
	{
		printf("Enter the module IP Address (XXX.XXX.XXX.XXX): ");
		gets(pc_IPAddressTemp);

		v_UTILS_ClearNullInIPAddress(pc_IPAddressTemp,pc_IPAddress);
		sprintf(pc_SOAPIPAddress,"%s:5555", pc_IPAddress);
		printf("SOAP IP Address: %s\n", pc_SOAPIPAddress);

		/* Get the module type */
		i_Error = soap_call_MXCommon__GetModuleType(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, &dw_Dummy, &s_ByteArrayResponse);
		if (i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, s_ByteArrayResponse.sResponse.iReturnValue, 0, "soap_call_MXCommon__GetModuleType", 1) == 0)
		{
			printf("Module Type: %s\n", s_ByteArrayResponse.sArray.__ptr);

            do
            {
                printf("Select the multifunction sub module (0 to 3):");
                scanf("%lu",&ulMFModuleIndex);
            }
            while (ulMFModuleIndex > 3);

            printf("\n");

            do
            {
                printf("Select the filter for the input A  0 to 262143 (0:Deactivated, 1:100ns ...262143:26,2 ms):");
                scanf("%lu",&ulInputAFilterValue);
            }
            while (ulInputAFilterValue > 262143);

            printf("\n");


            do
            {
                printf("Select the filter for the input B  0 to 262143 (0:Deactivated, 1:100ns ...262143:26,2 ms):");
                scanf("%lu",&ulInputBFilterValue);
            }
            while (ulInputBFilterValue > 262143);

            printf("\n");

            do
            {
                printf("Select the filter for the input C  0 to 262143 (0:Deactivated, 1:100ns ...262143:26,2 ms):");
                scanf("%lu",&ulInputCFilterValue);
            }
            while (ulInputCFilterValue > 262143);

            printf("\n");

            do
            {
                printf("Select the filter for the input D  0 to 262143 (0:Deactivated, 1:100ns ...262143:26,2 ms):");
                scanf("%lu",&ulInputDFilterValue);
            }
            while (ulInputDFilterValue > 262143);

            printf("\n");
									
			i_Error = soap_call_MSXE170x__MFCommonSetInputsFilter (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, ulMFModuleIndex,ulInputAFilterValue,ulInputBFilterValue,ulInputCFilterValue,ulInputDFilterValue,0,0,0,0, &Response); 
			i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFCommonSetInputsFilter", 0);

		}


		/* Close the SOAP connection */
		i_SOAP_Close(ps_SoapEnv);
	}
	else
		printf ("Can not open the soap socket\n");
   
	/**********************************/
	/*Print End programme informations*/
	/**********************************/
	printf("\n");
	printf("+---------------------------------------------------+\n");
	printf("| Program stopped                                   |\n");
	printf("+---------------------------------------------------+\n");
	printf("| Press any key to exit from sample                 |\n");
	printf("+---------------------------------------------------+\n");

	while (!(kbhit()));

}
