/** @file LatchRegister.c
* LatchRegister : MSX-E170x : Counter latch regsiter test program
* 
*
* @author C. Guinot
* @date 08.02.2007
* 
* @version  $LastChangedRevision$
* @version $LastChangedDate$
* 
* 
* @par LICENCE
* @par LICENCE
* @verbatim
*  Copyright (C) 2004,2005  ADDI-DATA GmbH for the source code of this module.
*        
*        ADDI-DATA GmbH 
*        Airport Boulevard B210
*        D-77836 Rheinmnster Germany 
*        Tel: +49(0)7229/1847-0 
*        Fax: +49(0)7229/1847-200
*        http://www.addi-data-com 
*        info@addi-data.com 
*        
*
* @endverbatim   
*
* @par UPDATES                                                                                                          
* @verbatim                                                                                                             
*  Date      : - 
*  Author        : -
*  Description   : -
*                                                                                                                       
* @endverbatim     
*
*
*/ 

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>


#include "..\..\..\..\..\..\Interface_Library\MSXE170x.nsmap"
#include "..\..\..\UTIL\utility.h"
#include "..\..\..\UTIL\socket.h"


#define	TIMESTAMP_USECOND_INDEX		0
#define	TIMESTAMP_SECOND_INDEX	1
#define SOURCE_COUNTER_INDEX	2
#define SOURCE_TYPE_INDEX		3
#define DATA_INDEX				4


unsigned long ulLatchRegister = 0;

HANDLE h_ConsoleHandle = NULL;
HANDLE h_ConsoleMutex  = NULL;

typedef struct
      {
      BYTE    b_Exit;
      SOCKET  s_ClientSocket;
      }str_ThreadInfo;


/********************
* dw_SocketThreadProc 
*********************/
/*+----------------------------------------------------------------------------+
*| Function   Name   : DWORD WINAPI dw_SocketThreadProc (LPVOID lpParameter)  |
*+----------------------------------------------------------------------------+
*| Task              : Read socket thread                                     |
*+----------------------------------------------------------------------------+
*| Input Parameters  : LPVOID lpParameter : Socket information's              |
*+----------------------------------------------------------------------------+
*| Output Parameters : -                                                      |
*+----------------------------------------------------------------------------+
*| Return Value      : 0                                                      |
*+----------------------------------------------------------------------------+*/
DWORD WINAPI dw_SocketThreadProc (LPVOID lpParameter)
        {
		INT               i_ReturnValue          = 0;
    	DWORD            dw_RequestValue         = 0;
    	DWORD            dw_NbrOfReceiveValues   = 0;
		DWORD            dw_Values[5]            = {0,0,0,0,0};
		BYTE *           pb_SocketData           = (BYTE *) dw_Values;
        str_ThreadInfo * ps_ThreadInfo           = (str_ThreadInfo *) lpParameter;
		DWORD			 dw_LatchCounter         = 0;
        
        do
			{
			dw_RequestValue       = sizeof (dw_Values);
			dw_NbrOfReceiveValues = 0;

			do
			{
				i_ReturnValue = recv (ps_ThreadInfo->s_ClientSocket, &pb_SocketData[dw_NbrOfReceiveValues], dw_RequestValue, 0); 

				if (i_ReturnValue != SOCKET_ERROR)
				{
					dw_NbrOfReceiveValues = dw_NbrOfReceiveValues + i_ReturnValue;
					dw_RequestValue       = dw_RequestValue - i_ReturnValue;
				}
			}
			while ((dw_NbrOfReceiveValues < sizeof (dw_Values)) && (i_ReturnValue != SOCKET_ERROR) && (ps_ThreadInfo->b_Exit == 0));


			if ((i_ReturnValue != SOCKET_ERROR) && (ps_ThreadInfo->b_Exit == 0))
			{
				/* Test if latch information are available */
				if ((dw_Values[SOURCE_TYPE_INDEX] == 2) || (dw_Values[SOURCE_TYPE_INDEX] == 3))
				{

				printf ("\nLatch occur : NbrOfLatch:%lu Counter %lu latch value = %lu Timestamp: ",++dw_LatchCounter, dw_Values[SOURCE_COUNTER_INDEX], dw_Values[DATA_INDEX]);
				DisplayTimeStamp (dw_Values[TIMESTAMP_SECOND_INDEX], dw_Values[TIMESTAMP_USECOND_INDEX]);
				}
			}
			else if (ps_ThreadInfo->b_Exit == 0)
			{
				printf ("Fail to receive data from the data socket\n");
				ps_ThreadInfo->b_Exit = 1;
			}


           } while (ps_ThreadInfo->b_Exit == 0);
        /*********************
        * Return from thread 
        **********************/
        return (0);

        }

/** Set counter configuration.
 * 
 * @retval 0:	No error.
 * @retval 1:	Error.
 */
int i_SAMPLE_CounterInitialization (struct soap *ps_SoapEnv, CHAR *pc_SOAPIPAddress, unsigned long *ulCounterIndex)
{
	struct MSXE170x__Response Response;
    struct MXCommon__Response CommonResponse;
	INT i_Error = 0;
	unsigned long  ulCounterMode = 0;
	unsigned long  ulCounterValue = 0;
	unsigned long  ulCounterOption = 0;
	unsigned long  ulTriggerEdgeSelection = 0;
	unsigned long  ulTriggerCount = 0;
	unsigned long  ulTriggerFilterTime = 0;
	unsigned long  ulFIFOLevel = 0;
	unsigned long  ulTimeOut = 0;
	unsigned long  ulSelection = 0;
	int ret = 0;

		do
		{
			printf("\nEnter the Index of the counter module (0 - 3): ");
			scanf("%lu", ulCounterIndex);
		}
		while (*ulCounterIndex > 3);

		do
		{
			printf("SIMPLE MODE		= %lu\n", MSXE170X_COUNTER_SIMPLE_MODE);
			printf("DOUBLE MODE		= %lu\n", MSXE170X_COUNTER_DOUBLE_MODE);
			printf("QUADRUPLE MODE	= %lu\n", MSXE170X_COUNTER_QUADRUPLE_MODE);
			printf("DIRECT MODE		= %lu\n", MSXE170X_COUNTER_DIRECT_MODE);
			printf("Set the counter mode for module %lu: ", *ulCounterIndex);
			scanf("%lu", &ulCounterMode);
		}
		while (	(ulCounterMode != MSXE170X_COUNTER_QUADRUPLE_MODE) && (ulCounterMode != MSXE170X_COUNTER_DOUBLE_MODE) &&
				(ulCounterMode != MSXE170X_COUNTER_SIMPLE_MODE) && (ulCounterMode != MSXE170X_COUNTER_DIRECT_MODE) );
		


		do
		{
			if (ulCounterMode != MSXE170X_COUNTER_DIRECT_MODE)
               {
               printf("HYSTERESIS ON = %lu\n",MSXE170X_COUNTER_HYSTERESIS_ON);
               printf("HYSTERESIS OFF = %lu\n",MSXE170X_COUNTER_HYSTERESIS_OFF);
               }
            else
               {
               printf("INCREMENT = %lu\n",MSXE170X_COUNTER_INCREMENT);
               printf("DECREMENT = %lu\n",MSXE170X_COUNTER_DECREMENT);
               }

			printf("Set the counter option for module %lu: ", *ulCounterIndex);
			scanf("%lu", &ulCounterOption);
		}
		while (	(ulCounterOption != MSXE170X_COUNTER_HYSTERESIS_ON) && (ulCounterOption != MSXE170X_COUNTER_HYSTERESIS_OFF) &&
				(ulCounterOption != MSXE170X_COUNTER_INCREMENT) && (ulCounterOption != MSXE170X_COUNTER_DECREMENT) );


		
		printf ("\n");	

		i_Error = soap_call_MSXE170x__MFIncCounterInit (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, 
												   *ulCounterIndex, 
												   ulCounterMode, 
												   ulCounterOption,
												   0,
                                                   0,
                                                   0,
                                                   0,
                                                   &Response); 

		if (i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFIncCounterInit", 0) == 1)
		{
			ret = 1;
			goto error;
		}

		/* You can specify a value at witch the counter will began to count */ 
		do
		{
			printf("\nEnter the value to write on counter %lu: ", *ulCounterIndex);
			scanf("%lu", &ulCounterValue);
		}
		while (ulCounterValue > 4294967295UL);
		
		printf ("\n");	
	
		i_Error = soap_call_MSXE170x__MFIncCounterWrite32BitValue (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, *ulCounterIndex, ulCounterValue, &Response); 
		i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFIncCounterWrite32BitValue", 0);
		

		/* specify the FIFO level */
		do
		{
			printf("\n Enter the FIFO level value (1 to 200): ");
			scanf("%lu",&ulFIFOLevel);

		}
		while ((ulFIFOLevel < 1) ||(ulFIFOLevel > 200));

		if (ulFIFOLevel > 1)
		{
		
			do
			{
				printf("\n Do You want to use a time out ? (0 : no, 1 : yes) :");
				scanf("%lu",&ulSelection);

			}
			while (ulSelection > 1);

			if (ulSelection == 1)
			{
				do
				{
					printf("\n Time out time base selection (1:us, 2:ms, 3:s): ");
					scanf("%lu",&ulSelection);

				}
				while ((ulSelection < 1) ||(ulSelection > 3));

				ulTimeOut = (ulSelection << 16);

				do
				{
					printf("\n Enter the time out value (1 to 200): ");
					scanf("%lu",&ulSelection);

				}
				while ((ulSelection < 1) ||(ulSelection > 200));
				
				ulTimeOut = ulTimeOut | ulSelection;

			}
		}

		i_Error = soap_call_MSXE170x__MFIncCounterSetFIFO0Level(ps_SoapEnv,pc_SOAPIPAddress, SOAP_ACTION,*ulCounterIndex,ulFIFOLevel,ulTimeOut,0,&Response);
		i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFIncCounterSetFIFO0Level", 0);



		// Latch register initialisation 
		do
		{
			printf("\nEnter the latch register value of counter %lu (0: trigger input, 1: synchro input): ", *ulCounterIndex);
			scanf("%lu", &ulLatchRegister );
		}
		while (ulLatchRegister > 1);

		if (ulLatchRegister == 0)
			{
			do
			{
				printf("Enter the trigger edge selection value of counter %lu (1:rising edge, 2:falling edge, 3:Both edge): ", *ulCounterIndex);
				scanf("%lu", &ulTriggerEdgeSelection );
			}
			while ((ulTriggerEdgeSelection > 3) || (ulTriggerEdgeSelection < 1));

			do
			{
				printf("Enter the trigger count value of counter %lu (1:all trigger start the latch, max value : 65535): ", *ulCounterIndex);
				scanf("%lu", &ulTriggerCount );
			}
			while ((ulTriggerCount > 65535) || (ulTriggerCount < 1));

			}

		i_Error = soap_call_MSXE170x__MFIncCounterInitAndEnableLatchRegister(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, *ulCounterIndex, ulLatchRegister, ulTriggerEdgeSelection, ulTriggerCount, 0, &Response);
		i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFIncCounterInitAndEnableLatchRegister", 0);


		if (ulLatchRegister == 0)
		{
    		do
	    	{
		    	printf("\nEnter the trigger filter time value (0:not used, max value:65535): ");
    			scanf("%lu", &ulTriggerFilterTime );
	    	}
		    while (ulTriggerFilterTime > 65535);

		    i_Error = soap_call_MXCommon__SetHardwareTriggerFilterTime(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, ulTriggerFilterTime, 0, &CommonResponse);
			i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, CommonResponse.iReturnValue, 0, "soap_call_MXCommon__SetHardwareTriggerFilterTime", 0);
		    
        }

error:
		/* 
		 * gSOAP doesn't release automatically the memory that 
		 * it allocates to deserialize data, that's why both 
		 * following functions have to be used to release the 
		 * allocated memory.
		 */
		soap_destroy(ps_SoapEnv);
		soap_end(ps_SoapEnv);

	return ret;
}

//-------------------------------------------------------------------------------------------------------

/** Release counter.
 * 
 * @retval 0:	No error.
 * @retval 1:	Error.
 */
int i_SAMPLE_ReleaseCounter (struct soap *ps_SoapEnv, CHAR *pc_SOAPIPAddress, unsigned long ulCounterIndex)
{
	struct MSXE170x__Response Response;
	INT i_Error = 0;

		i_Error = soap_call_MSXE170x__MFIncCounterDisableAndReleaseLatchRegister(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, ulCounterIndex, ulLatchRegister, 0, &Response);
		i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFIncCounterDisableAndReleaseLatchRegister", 0);

		i_Error = soap_call_MSXE170x__MFIncCounterRelease (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, ulCounterIndex, &Response); 
		if (i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, Response.iReturnValue, 0, "soap_call_MSXE170x__MFIncCounterRelease", 0) == 1)
			return 1;
	
	return 0;
}



void main(void)
{
	INT i_Error = 0;
	struct soap *ps_SoapEnv = NULL;
	struct MXCommon__ByteArrayResponse  s_ByteArrayResponse;
	CHAR pc_IPAddressTemp[50];
	CHAR pc_IPAddress[50];
	CHAR pc_SOAPIPAddress[50];
	SOCKET  s_ClientSocket;
	DWORD dw_Dummy = 0;
    DWORD                   dw_ThreadId               = 0;
	INT i_ReturnValue = 0;
	BYTE b_Exit = 0;
    HANDLE                   h_TreadHandle            = 0;
    str_ThreadInfo   s_ThreadInfo;
	unsigned long ulCounterIndex = 0;
	int i_key = 0;


	/* Get the console handle */
	h_ConsoleHandle = GetStdHandle(STD_OUTPUT_HANDLE);
	h_ConsoleMutex  = CreateMutex (NULL, FALSE, "MSX-E170x LatchRegister"); 
	ShowWindow(GetForegroundWindow (), SW_SHOWMAXIMIZED);

	/* Print sample information */
	printf("+---------------------------------------------------+\n");
	printf("| MSX-E170x                                         |\n");
	printf("| counter latch regsiter test program               |\n");
	printf("+---------------------------------------------------+\n");
	printf("| <ESC> exit sample                                 |\n");
	printf("+---------------------------------------------------+\n");
	printf("\n");

	/* Initialise the SOAP connection */
	if (i_SOAP_Init(&ps_SoapEnv) == 0)
	{
		printf("Enter the module IP Address (XXX.XXX.XXX.XXX): ");
		gets(pc_IPAddressTemp);
		
		v_UTILS_ClearNullInIPAddress(pc_IPAddressTemp,pc_IPAddress);
		sprintf(pc_SOAPIPAddress,"%s:5555", pc_IPAddress);
		printf("SOAP IP Address: %s\n", pc_SOAPIPAddress);

		/* Get the module type */
		i_Error = soap_call_MXCommon__GetModuleType(ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, &dw_Dummy, &s_ByteArrayResponse);
		if (i_CheckAndPrintError (ps_SoapEnv, pc_SOAPIPAddress, SOAP_ACTION, i_Error, s_ByteArrayResponse.sResponse.iReturnValue, 0, "soap_call_MXCommon__GetModuleType", 1) == 0)
		{
			printf("Module Type: %s\n", s_ByteArrayResponse.sArray.__ptr);
									
			if (i_SAMPLE_CounterInitialization (ps_SoapEnv, pc_SOAPIPAddress, &ulCounterIndex) == 0) 
			{

				/* Initialise the socket to receive the data */
				if (i_Socket_ClientOpen(pc_IPAddress, 8989, &s_ClientSocket) == 0)
				{

				    s_ThreadInfo.s_ClientSocket = s_ClientSocket;
				    s_ThreadInfo.b_Exit = 0;

				    // Creat the keaboard thread
				    h_TreadHandle = CreateThread (NULL,
					 	            		      0,
								                  dw_SocketThreadProc,
									              &s_ThreadInfo,
									              0,
									              &dw_ThreadId);
   
			        Sleep (100);

				    /* Start the counter */
				    printf ("\nPress ESC to quit.\n");
				    getch();

				    do 
                    {
					

					    /* Press any key to clear the counter */
					    if (kbhit()) 
					    {
						    i_key = getch();
					    }

				    /* Exit on ESC */
				    } while ((i_key != 27) && (!s_ThreadInfo.b_Exit));
				
				    s_ThreadInfo.b_Exit = 1;
                    printf("\n");


				    Sleep (100);
				
		            /******************
		            * Free the thread 
		            *******************/
		            /***************************
		            * Test if thread installed 
		            ****************************/
		            if (h_TreadHandle != 0)
			        {
			            /*************************
			            * Close the tread handle 
			            **************************/
			            CloseHandle (h_TreadHandle);
           
				    }





					/* Close the socket connection */
					i_Socket_ClientClose(s_ClientSocket);
				}
				else
				{
					printf("i_Socket_ClientOpen Error\n");
				}
			
			i_SAMPLE_ReleaseCounter (ps_SoapEnv, pc_SOAPIPAddress, ulCounterIndex);
			}

		}

		/* Close the SOAP connection */
		i_SOAP_Close(ps_SoapEnv);
	}
	else
		printf ("Can not open the soap socket\n");
   
	/**********************************/
	/*Print End programme informations*/
	/**********************************/
	printf("\n");
	printf("+---------------------------------------------------+\n");
	printf("| Program stopped                                   |\n");
	printf("+---------------------------------------------------+\n");
	printf("| Press any key to exit from sample                 |\n");
	printf("+---------------------------------------------------+\n");

	while (!(kbhit()));

	/****************************/
	/* Close the console handle */
	/****************************/
	if (h_ConsoleHandle != NULL)
	{
		/****************************/
		/* Clodse the console handle */
		/****************************/
		CloseHandle(h_ConsoleHandle);
		CloseHandle(h_ConsoleMutex);
	}
}
